/* game.c generated by valac 0.28.0, the Vala compiler
 * generated from game.vala, do not modify */

/* Copyright (C) 2014-2015 Juan R. García Blanco
 *
 * This file is part of GNOME 2048.
 *
 * GNOME 2048 is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME 2048 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME 2048; if not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <clutter/clutter.h>
#include <gee.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>


#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef struct _GamePrivate GamePrivate;

#define TYPE_GRID (grid_get_type ())
#define GRID(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GRID, Grid))
#define GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GRID, GridClass))
#define IS_GRID(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GRID))
#define IS_GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GRID))
#define GRID_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GRID, GridClass))

typedef struct _Grid Grid;
typedef struct _GridClass GridClass;

#define TYPE_ROUNDED_RECTANGLE (rounded_rectangle_get_type ())
#define ROUNDED_RECTANGLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ROUNDED_RECTANGLE, RoundedRectangle))
#define ROUNDED_RECTANGLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ROUNDED_RECTANGLE, RoundedRectangleClass))
#define IS_ROUNDED_RECTANGLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ROUNDED_RECTANGLE))
#define IS_ROUNDED_RECTANGLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ROUNDED_RECTANGLE))
#define ROUNDED_RECTANGLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ROUNDED_RECTANGLE, RoundedRectangleClass))

typedef struct _RoundedRectangle RoundedRectangle;
typedef struct _RoundedRectangleClass RoundedRectangleClass;

#define TYPE_TILE_VIEW (tile_view_get_type ())
#define TILE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TILE_VIEW, TileView))
#define TILE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TILE_VIEW, TileViewClass))
#define IS_TILE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TILE_VIEW))
#define IS_TILE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TILE_VIEW))
#define TILE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TILE_VIEW, TileViewClass))

typedef struct _TileView TileView;
typedef struct _TileViewClass TileViewClass;

#define TYPE_TILE_MOVEMENT (tile_movement_get_type ())

#define TYPE_GRID_POSITION (grid_position_get_type ())
typedef struct _GridPosition GridPosition;
typedef struct _TileMovement TileMovement;

#define TYPE_TILE (tile_get_type ())
typedef struct _Tile Tile;

#define GAME_TYPE_GAME_STATE (game_game_state_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _tile_movement_free0(var) ((var == NULL) ? NULL : (var = (tile_movement_free (var), NULL)))
#define _tile_free0(var) ((var == NULL) ? NULL : (var = (tile_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Game {
	GObject parent_instance;
	GamePrivate * priv;
};

struct _GameClass {
	GObjectClass parent_class;
};

struct _GridPosition {
	guint row;
	guint col;
};

struct _TileMovement {
	GridPosition from;
	GridPosition to;
};

struct _Tile {
	GridPosition pos;
	guint val;
};

typedef enum  {
	GAME_GAME_STATE_STOPPED,
	GAME_GAME_STATE_IDLE,
	GAME_GAME_STATE_MOVING_DOWN,
	GAME_GAME_STATE_MOVING_UP,
	GAME_GAME_STATE_MOVING_RIGHT,
	GAME_GAME_STATE_MOVING_LEFT,
	GAME_GAME_STATE_SHOWING_FIRST_TILE,
	GAME_GAME_STATE_SHOWING_SECOND_TILE,
	GAME_GAME_STATE_RESTORING_TILES
} GameGameState;

struct _GamePrivate {
	gint BLANK_ROW_HEIGHT;
	gint BLANK_COL_WIDTH;
	Grid* _grid;
	ClutterActor* _view;
	RoundedRectangle** _background;
	gint _background_length1;
	gint _background_length2;
	TileView** _foreground_cur;
	gint _foreground_cur_length1;
	gint _foreground_cur_length2;
	TileView** _foreground_nxt;
	gint _foreground_nxt_length1;
	gint _foreground_nxt_length2;
	GeeLinkedList* _to_move;
	GeeLinkedList* _to_hide;
	GeeLinkedList* _to_show;
	GameGameState _state;
	ClutterTransitionGroup* _show_hide_trans;
	ClutterTransitionGroup* _move_trans;
	GSettings* _settings;
	gchar* _saved_path;
	guint _score;
};


static gpointer game_parent_class = NULL;

GType game_get_type (void) G_GNUC_CONST;
GType grid_get_type (void) G_GNUC_CONST;
GType rounded_rectangle_get_type (void) G_GNUC_CONST;
GType tile_view_get_type (void) G_GNUC_CONST;
GType tile_movement_get_type (void) G_GNUC_CONST;
GType grid_position_get_type (void) G_GNUC_CONST;
GridPosition* grid_position_dup (const GridPosition* self);
void grid_position_free (GridPosition* self);
TileMovement* tile_movement_dup (const TileMovement* self);
void tile_movement_free (TileMovement* self);
GType tile_get_type (void) G_GNUC_CONST;
Tile* tile_dup (const Tile* self);
void tile_free (Tile* self);
static GType game_game_state_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define GAME_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_GAME, GamePrivate))
enum  {
	GAME_DUMMY_PROPERTY,
	GAME_VIEW,
	GAME_SCORE
};
Game* game_new (GSettings* settings);
Game* game_construct (GType object_type, GSettings* settings);
Grid* grid_new (gint rows, gint cols);
Grid* grid_construct (GType object_type, gint rows, gint cols);
void game_new_game (Game* self);
void grid_clear (Grid* self);
static void _game_clear_foreground (Game* self);
void game_set_score (Game* self, guint value);
static void _game_create_random_tile (Game* self);
void game_save_game (Game* self);
gchar* grid_save (Grid* self);
gboolean game_restore_game (Game* self);
gboolean grid_load (Grid* self, const gchar* content);
static void _game_init_background (Game* self);
static void _game_restore_foreground (Game* self);
gboolean game_key_pressed (Game* self, GdkEventKey* event);
static guint _game_upper_key (Game* self, guint keyval);
static void _game_move_down (Game* self);
static void _game_move_up (Game* self);
static void _game_move_left (Game* self);
static void _game_move_right (Game* self);
gboolean game_reload_settings (Game* self);
gint grid_get_rows (Grid* self);
gint grid_get_cols (Grid* self);
static void _game_clear_background (Game* self);
static void _game_on_allocation_changed (Game* self, ClutterActorBox* box, ClutterAllocationFlags flags);
static void _game_resize_view (Game* self);
RoundedRectangle* rounded_rectangle_new (gfloat x, gfloat y, gfloat width, gfloat height, ClutterColor* color);
RoundedRectangle* rounded_rectangle_construct (GType object_type, gfloat x, gfloat y, gfloat width, gfloat height, ClutterColor* color);
ClutterActor* rounded_rectangle_get_actor (RoundedRectangle* self);
ClutterCanvas* rounded_rectangle_get_canvas (RoundedRectangle* self);
void rounded_rectangle_resize (RoundedRectangle* self, gfloat x, gfloat y, gfloat width, gfloat height);
gboolean grid_new_tile (Grid* self, Tile* tile);
static void _game_create_show_hide_transition (Game* self);
static void _game_create_tile (Game* self, Tile* tile);
static void _game_show_tile (Game* self, GridPosition* pos);
TileView* tile_view_new (gfloat x, gfloat y, gfloat width, gfloat height, guint val);
TileView* tile_view_construct (GType object_type, gfloat x, gfloat y, gfloat width, gfloat height, guint val);
static void _game_on_move_trans_stopped (Game* self, gboolean is_finished);
static void __game_on_move_trans_stopped_clutter_timeline_stopped (ClutterTimeline* _sender, gboolean is_finished, gpointer self);
void grid_move_down (Grid* self, GeeLinkedList* to_move, GeeLinkedList* to_hide, GeeLinkedList* to_show);
static void _game_move_tile (Game* self, GridPosition* from, GridPosition* to);
static void _game_prepare_move_tile (Game* self, GridPosition* from, GridPosition* to);
void grid_move_up (Grid* self, GeeLinkedList* to_move, GeeLinkedList* to_hide, GeeLinkedList* to_show);
void grid_move_left (Grid* self, GeeLinkedList* to_move, GeeLinkedList* to_hide, GeeLinkedList* to_show);
void grid_move_right (Grid* self, GeeLinkedList* to_move, GeeLinkedList* to_hide, GeeLinkedList* to_show);
gchar* grid_position_to_string (GridPosition *self);
static void _game_dim_tile (Game* self, GridPosition* pos);
guint tile_view_get_value (TileView* self);
guint grid_get (Grid* self, gint row, gint col);
gchar* grid_to_string (Grid* self);
guint game_get_score (Game* self);
static void _game_on_show_hide_trans_stopped (Game* self, gboolean is_finished);
static void _game_finish_move (Game* self);
static void __game_on_show_hide_trans_stopped_clutter_timeline_stopped (ClutterTimeline* _sender, gboolean is_finished, gpointer self);
gboolean grid_is_finished (Grid* self);
ClutterActor* game_get_view (Game* self);
void game_set_view (Game* self, ClutterActor* value);
static void __game_on_allocation_changed_clutter_actor_allocation_changed (ClutterActor* _sender, ClutterActorBox* box, ClutterAllocationFlags flags, gpointer self);
static void game_finalize (GObject* obj);
static void _vala_game_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_game_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static GType game_game_state_get_type (void) {
	static volatile gsize game_game_state_type_id__volatile = 0;
	if (g_once_init_enter (&game_game_state_type_id__volatile)) {
		static const GEnumValue values[] = {{GAME_GAME_STATE_STOPPED, "GAME_GAME_STATE_STOPPED", "stopped"}, {GAME_GAME_STATE_IDLE, "GAME_GAME_STATE_IDLE", "idle"}, {GAME_GAME_STATE_MOVING_DOWN, "GAME_GAME_STATE_MOVING_DOWN", "moving-down"}, {GAME_GAME_STATE_MOVING_UP, "GAME_GAME_STATE_MOVING_UP", "moving-up"}, {GAME_GAME_STATE_MOVING_RIGHT, "GAME_GAME_STATE_MOVING_RIGHT", "moving-right"}, {GAME_GAME_STATE_MOVING_LEFT, "GAME_GAME_STATE_MOVING_LEFT", "moving-left"}, {GAME_GAME_STATE_SHOWING_FIRST_TILE, "GAME_GAME_STATE_SHOWING_FIRST_TILE", "showing-first-tile"}, {GAME_GAME_STATE_SHOWING_SECOND_TILE, "GAME_GAME_STATE_SHOWING_SECOND_TILE", "showing-second-tile"}, {GAME_GAME_STATE_RESTORING_TILES, "GAME_GAME_STATE_RESTORING_TILES", "restoring-tiles"}, {0, NULL, NULL}};
		GType game_game_state_type_id;
		game_game_state_type_id = g_enum_register_static ("GameGameState", values);
		g_once_init_leave (&game_game_state_type_id__volatile, game_game_state_type_id);
	}
	return game_game_state_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


Game* game_construct (GType object_type, GSettings* settings) {
	Game * self = NULL;
	GSettings* _tmp0_ = NULL;
	GSettings* _tmp1_ = NULL;
	gint rows = 0;
	GSettings* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint cols = 0;
	GSettings* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	Grid* _tmp6_ = NULL;
	GeeLinkedList* _tmp7_ = NULL;
	GeeLinkedList* _tmp8_ = NULL;
	GeeLinkedList* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	g_return_val_if_fail (settings != NULL, NULL);
	self = (Game*) g_object_new (object_type, NULL);
	_tmp0_ = settings;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_settings);
	self->priv->_settings = _tmp1_;
	_tmp2_ = self->priv->_settings;
	_tmp3_ = g_settings_get_int (_tmp2_, "rows");
	rows = _tmp3_;
	_tmp4_ = self->priv->_settings;
	_tmp5_ = g_settings_get_int (_tmp4_, "cols");
	cols = _tmp5_;
	_tmp6_ = grid_new (rows, cols);
	_g_object_unref0 (self->priv->_grid);
	self->priv->_grid = _tmp6_;
	_tmp7_ = gee_linked_list_new (TYPE_TILE_MOVEMENT, (GBoxedCopyFunc) tile_movement_dup, tile_movement_free, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->_to_move);
	self->priv->_to_move = _tmp7_;
	_tmp8_ = gee_linked_list_new (TYPE_TILE_MOVEMENT, (GBoxedCopyFunc) tile_movement_dup, tile_movement_free, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->_to_hide);
	self->priv->_to_hide = _tmp8_;
	_tmp9_ = gee_linked_list_new (TYPE_TILE, (GBoxedCopyFunc) tile_dup, tile_free, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->_to_show);
	self->priv->_to_show = _tmp9_;
	_tmp10_ = g_get_user_data_dir ();
	_tmp11_ = g_build_filename (_tmp10_, "gnome-2048", "saved", NULL);
	_g_free0 (self->priv->_saved_path);
	self->priv->_saved_path = _tmp11_;
	self->priv->_state = GAME_GAME_STATE_STOPPED;
	return self;
}


Game* game_new (GSettings* settings) {
	return game_construct (TYPE_GAME, settings);
}


void game_new_game (Game* self) {
	Grid* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_grid;
	grid_clear (_tmp0_);
	_game_clear_foreground (self);
	game_set_score (self, (guint) 0);
	self->priv->_state = GAME_GAME_STATE_SHOWING_FIRST_TILE;
	_game_create_random_tile (self);
}


void game_save_game (Game* self) {
	gchar* contents = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	Grid* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	guint _tmp7_ = 0U;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup ("");
	contents = _tmp0_;
	_tmp1_ = contents;
	_tmp2_ = self->priv->_grid;
	_tmp3_ = grid_save (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp1_, _tmp4_, NULL);
	_g_free0 (contents);
	contents = _tmp5_;
	_g_free0 (_tmp4_);
	_tmp6_ = contents;
	_tmp7_ = self->priv->_score;
	_tmp8_ = g_strdup_printf ("%u", _tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_strconcat (_tmp9_, "\n", NULL);
	_tmp11_ = _tmp10_;
	_tmp12_ = g_strconcat (_tmp6_, _tmp11_, NULL);
	_g_free0 (contents);
	contents = _tmp12_;
	_g_free0 (_tmp11_);
	_g_free0 (_tmp9_);
	{
		const gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		const gchar* _tmp16_ = NULL;
		const gchar* _tmp17_ = NULL;
		_tmp13_ = self->priv->_saved_path;
		_tmp14_ = g_path_get_dirname (_tmp13_);
		_tmp15_ = _tmp14_;
		g_mkdir_with_parents (_tmp15_, 0775);
		_g_free0 (_tmp15_);
		_tmp16_ = self->priv->_saved_path;
		_tmp17_ = contents;
		g_file_set_contents (_tmp16_, _tmp17_, (gssize) (-1), &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch7_g_file_error;
			}
			_g_free0 (contents);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		g_debug ("game.vala:107: game saved successfully");
	}
	goto __finally7;
	__catch7_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp18_ = NULL;
		const gchar* _tmp19_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp18_ = e;
		_tmp19_ = _tmp18_->message;
		g_warning ("game.vala:109: Failed to save game: %s", _tmp19_);
		_g_error_free0 (e);
	}
	__finally7:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (contents);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_free0 (contents);
}


gboolean game_restore_game (Game* self) {
	gboolean result = FALSE;
	gchar* contents = NULL;
	gchar** lines = NULL;
	gint lines_length1 = 0;
	gint _lines_size_ = 0;
	Grid* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_ = NULL;
	gchar** _tmp8_ = NULL;
	gchar** _tmp9_ = NULL;
	gchar** _tmp10_ = NULL;
	gint _tmp10__length1 = 0;
	gchar** _tmp11_ = NULL;
	gint _tmp11__length1 = 0;
	const gchar* _tmp12_ = NULL;
	gint _tmp13_ = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		_tmp0_ = self->priv->_saved_path;
		g_file_get_contents (_tmp0_, &_tmp1_, NULL, &_inner_error_);
		_g_free0 (contents);
		contents = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch8_g_file_error;
			}
			lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
			_g_free0 (contents);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	goto __finally8;
	__catch8_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp2_ = e;
		_tmp3_ = _tmp2_->message;
		g_warning ("game.vala:121: Failed to save game: %s", _tmp3_);
		result = FALSE;
		_g_error_free0 (e);
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (contents);
		return result;
	}
	__finally8:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (contents);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	_tmp4_ = self->priv->_grid;
	_tmp5_ = contents;
	_tmp6_ = grid_load (_tmp4_, _tmp5_);
	if (!_tmp6_) {
		result = FALSE;
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (contents);
		return result;
	}
	_tmp7_ = contents;
	_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, "\n", 0);
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
	lines = _tmp9_;
	lines_length1 = _vala_array_length (_tmp8_);
	_lines_size_ = lines_length1;
	_tmp10_ = lines;
	_tmp10__length1 = lines_length1;
	_tmp11_ = lines;
	_tmp11__length1 = lines_length1;
	_tmp12_ = _tmp10_[_tmp11__length1 - 2];
	_tmp13_ = atoi (_tmp12_);
	game_set_score (self, (guint) _tmp13_);
	_game_init_background (self);
	_game_restore_foreground (self);
	g_debug ("game.vala:134: game restored successfully");
	result = TRUE;
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (contents);
	return result;
}


gboolean game_key_pressed (Game* self, GdkEventKey* event) {
	gboolean result = FALSE;
	GameGameState _tmp0_ = 0;
	guint keyval = 0U;
	GdkEventKey* _tmp1_ = NULL;
	guint _tmp2_ = 0U;
	guint _tmp3_ = 0U;
	guint _tmp4_ = 0U;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->_state;
	if (_tmp0_ != GAME_GAME_STATE_IDLE) {
		result = TRUE;
		return result;
	}
	_tmp1_ = event;
	_tmp2_ = _tmp1_->keyval;
	_tmp3_ = _game_upper_key (self, _tmp2_);
	keyval = _tmp3_;
	_tmp4_ = keyval;
	if (_tmp4_ == ((guint) GDK_KEY_Down)) {
		_game_move_down (self);
	} else {
		guint _tmp5_ = 0U;
		_tmp5_ = keyval;
		if (_tmp5_ == ((guint) GDK_KEY_Up)) {
			_game_move_up (self);
		} else {
			guint _tmp6_ = 0U;
			_tmp6_ = keyval;
			if (_tmp6_ == ((guint) GDK_KEY_Left)) {
				_game_move_left (self);
			} else {
				guint _tmp7_ = 0U;
				_tmp7_ = keyval;
				if (_tmp7_ == ((guint) GDK_KEY_Right)) {
					_game_move_right (self);
				}
			}
		}
	}
	result = FALSE;
	return result;
}


gboolean game_reload_settings (Game* self) {
	gboolean result = FALSE;
	gint rows = 0;
	GSettings* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint cols = 0;
	GSettings* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	gint _tmp5_ = 0;
	Grid* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_settings;
	_tmp1_ = g_settings_get_int (_tmp0_, "rows");
	rows = _tmp1_;
	_tmp2_ = self->priv->_settings;
	_tmp3_ = g_settings_get_int (_tmp2_, "cols");
	cols = _tmp3_;
	_tmp5_ = rows;
	_tmp6_ = self->priv->_grid;
	_tmp7_ = grid_get_rows (_tmp6_);
	_tmp8_ = _tmp7_;
	if (_tmp5_ != _tmp8_) {
		_tmp4_ = TRUE;
	} else {
		gint _tmp9_ = 0;
		Grid* _tmp10_ = NULL;
		gint _tmp11_ = 0;
		gint _tmp12_ = 0;
		_tmp9_ = cols;
		_tmp10_ = self->priv->_grid;
		_tmp11_ = grid_get_cols (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp4_ = _tmp9_ != _tmp12_;
	}
	if (_tmp4_) {
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		Grid* _tmp15_ = NULL;
		_game_clear_foreground (self);
		_game_clear_background (self);
		_game_init_background (self);
		_tmp13_ = rows;
		_tmp14_ = cols;
		_tmp15_ = grid_new (_tmp13_, _tmp14_);
		_g_object_unref0 (self->priv->_grid);
		self->priv->_grid = _tmp15_;
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static guint _game_upper_key (Game* self, guint keyval) {
	guint result = 0U;
	guint _tmp0_ = 0U;
	guint _tmp1_ = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp1_ = keyval;
	if (_tmp1_ > ((guint) 255)) {
		guint _tmp2_ = 0U;
		_tmp2_ = keyval;
		_tmp0_ = _tmp2_;
	} else {
		guint _tmp3_ = 0U;
		gchar _tmp4_ = '\0';
		_tmp3_ = keyval;
		_tmp4_ = g_ascii_toupper ((gchar) _tmp3_);
		_tmp0_ = (guint) _tmp4_;
	}
	result = _tmp0_;
	return result;
}


static void _game_on_allocation_changed (Game* self, ClutterActorBox* box, ClutterAllocationFlags flags) {
	RoundedRectangle** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (box != NULL);
	_tmp0_ = self->priv->_background;
	_tmp0__length1 = self->priv->_background_length1;
	_tmp0__length2 = self->priv->_background_length2;
	if (_tmp0_ == NULL) {
		_game_init_background (self);
	} else {
		_game_resize_view (self);
	}
}


static void _game_init_background (Game* self) {
	gint rows = 0;
	Grid* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint cols = 0;
	Grid* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	ClutterColor background_color = {0};
	ClutterActor* _tmp6_ = NULL;
	ClutterColor _tmp7_ = {0};
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	RoundedRectangle** _tmp10_ = NULL;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	TileView** _tmp13_ = NULL;
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
	TileView** _tmp16_ = NULL;
	gfloat canvas_width = 0.0F;
	ClutterActor* _tmp17_ = NULL;
	gfloat _tmp18_ = 0.0F;
	gfloat _tmp19_ = 0.0F;
	gfloat canvas_height = 0.0F;
	ClutterActor* _tmp20_ = NULL;
	gfloat _tmp21_ = 0.0F;
	gfloat _tmp22_ = 0.0F;
	gfloat _tmp23_ = 0.0F;
	gint _tmp24_ = 0;
	gint _tmp25_ = 0;
	gfloat _tmp26_ = 0.0F;
	gint _tmp27_ = 0;
	gint _tmp28_ = 0;
	gfloat tile_width = 0.0F;
	gfloat _tmp29_ = 0.0F;
	gint _tmp30_ = 0;
	gfloat tile_height = 0.0F;
	gfloat _tmp31_ = 0.0F;
	gint _tmp32_ = 0;
	ClutterColor color = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_grid;
	_tmp1_ = grid_get_rows (_tmp0_);
	_tmp2_ = _tmp1_;
	rows = _tmp2_;
	_tmp3_ = self->priv->_grid;
	_tmp4_ = grid_get_cols (_tmp3_);
	_tmp5_ = _tmp4_;
	cols = _tmp5_;
	clutter_color_from_string (&background_color, "#babdb6");
	_tmp6_ = self->priv->_view;
	_tmp7_ = background_color;
	clutter_actor_set_background_color (_tmp6_, &_tmp7_);
	_tmp8_ = rows;
	_tmp9_ = cols;
	_tmp10_ = g_new0 (RoundedRectangle*, (_tmp8_ * _tmp9_) + 1);
	self->priv->_background = (_vala_array_free (self->priv->_background, self->priv->_background_length1 * self->priv->_background_length2, (GDestroyNotify) g_object_unref), NULL);
	self->priv->_background = _tmp10_;
	self->priv->_background_length1 = _tmp8_;
	self->priv->_background_length2 = _tmp9_;
	_tmp11_ = rows;
	_tmp12_ = cols;
	_tmp13_ = g_new0 (TileView*, (_tmp11_ * _tmp12_) + 1);
	self->priv->_foreground_cur = (_vala_array_free (self->priv->_foreground_cur, self->priv->_foreground_cur_length1 * self->priv->_foreground_cur_length2, (GDestroyNotify) g_object_unref), NULL);
	self->priv->_foreground_cur = _tmp13_;
	self->priv->_foreground_cur_length1 = _tmp11_;
	self->priv->_foreground_cur_length2 = _tmp12_;
	_tmp14_ = rows;
	_tmp15_ = cols;
	_tmp16_ = g_new0 (TileView*, (_tmp14_ * _tmp15_) + 1);
	self->priv->_foreground_nxt = (_vala_array_free (self->priv->_foreground_nxt, self->priv->_foreground_nxt_length1 * self->priv->_foreground_nxt_length2, (GDestroyNotify) g_object_unref), NULL);
	self->priv->_foreground_nxt = _tmp16_;
	self->priv->_foreground_nxt_length1 = _tmp14_;
	self->priv->_foreground_nxt_length2 = _tmp15_;
	_tmp17_ = self->priv->_view;
	_tmp18_ = clutter_actor_get_width (_tmp17_);
	_tmp19_ = _tmp18_;
	canvas_width = _tmp19_;
	_tmp20_ = self->priv->_view;
	_tmp21_ = clutter_actor_get_height (_tmp20_);
	_tmp22_ = _tmp21_;
	canvas_height = _tmp22_;
	_tmp23_ = canvas_width;
	_tmp24_ = cols;
	_tmp25_ = self->priv->BLANK_COL_WIDTH;
	canvas_width = _tmp23_ - ((_tmp24_ + 1) * _tmp25_);
	_tmp26_ = canvas_height;
	_tmp27_ = rows;
	_tmp28_ = self->priv->BLANK_ROW_HEIGHT;
	canvas_height = _tmp26_ - ((_tmp27_ + 1) * _tmp28_);
	_tmp29_ = canvas_width;
	_tmp30_ = cols;
	tile_width = _tmp29_ / _tmp30_;
	_tmp31_ = canvas_height;
	_tmp32_ = rows;
	tile_height = _tmp31_ / _tmp32_;
	clutter_color_from_string (&color, "#ffffff");
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp33_ = FALSE;
			_tmp33_ = TRUE;
			while (TRUE) {
				gint _tmp35_ = 0;
				gint _tmp36_ = 0;
				if (!_tmp33_) {
					gint _tmp34_ = 0;
					_tmp34_ = i;
					i = _tmp34_ + 1;
				}
				_tmp33_ = FALSE;
				_tmp35_ = i;
				_tmp36_ = rows;
				if (!(_tmp35_ < _tmp36_)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp37_ = FALSE;
						_tmp37_ = TRUE;
						while (TRUE) {
							gint _tmp39_ = 0;
							gint _tmp40_ = 0;
							gfloat x = 0.0F;
							gint _tmp41_ = 0;
							gfloat _tmp42_ = 0.0F;
							gint _tmp43_ = 0;
							gint _tmp44_ = 0;
							gfloat y = 0.0F;
							gint _tmp45_ = 0;
							gfloat _tmp46_ = 0.0F;
							gint _tmp47_ = 0;
							gint _tmp48_ = 0;
							RoundedRectangle* rect = NULL;
							gfloat _tmp49_ = 0.0F;
							gfloat _tmp50_ = 0.0F;
							gfloat _tmp51_ = 0.0F;
							gfloat _tmp52_ = 0.0F;
							ClutterColor _tmp53_ = {0};
							RoundedRectangle* _tmp54_ = NULL;
							ClutterActor* _tmp55_ = NULL;
							RoundedRectangle* _tmp56_ = NULL;
							ClutterActor* _tmp57_ = NULL;
							ClutterActor* _tmp58_ = NULL;
							RoundedRectangle* _tmp59_ = NULL;
							ClutterCanvas* _tmp60_ = NULL;
							ClutterCanvas* _tmp61_ = NULL;
							RoundedRectangle* _tmp62_ = NULL;
							ClutterActor* _tmp63_ = NULL;
							ClutterActor* _tmp64_ = NULL;
							RoundedRectangle** _tmp65_ = NULL;
							gint _tmp65__length1 = 0;
							gint _tmp65__length2 = 0;
							gint _tmp66_ = 0;
							gint _tmp67_ = 0;
							RoundedRectangle* _tmp68_ = NULL;
							RoundedRectangle* _tmp69_ = NULL;
							RoundedRectangle* _tmp70_ = NULL;
							if (!_tmp37_) {
								gint _tmp38_ = 0;
								_tmp38_ = j;
								j = _tmp38_ + 1;
							}
							_tmp37_ = FALSE;
							_tmp39_ = j;
							_tmp40_ = cols;
							if (!(_tmp39_ < _tmp40_)) {
								break;
							}
							_tmp41_ = j;
							_tmp42_ = tile_width;
							_tmp43_ = j;
							_tmp44_ = self->priv->BLANK_COL_WIDTH;
							x = (_tmp41_ * _tmp42_) + ((_tmp43_ + 1) * _tmp44_);
							_tmp45_ = i;
							_tmp46_ = tile_height;
							_tmp47_ = i;
							_tmp48_ = self->priv->BLANK_ROW_HEIGHT;
							y = (_tmp45_ * _tmp46_) + ((_tmp47_ + 1) * _tmp48_);
							_tmp49_ = x;
							_tmp50_ = y;
							_tmp51_ = tile_width;
							_tmp52_ = tile_height;
							_tmp53_ = color;
							_tmp54_ = rounded_rectangle_new (_tmp49_, _tmp50_, _tmp51_, _tmp52_, &_tmp53_);
							rect = _tmp54_;
							_tmp55_ = self->priv->_view;
							_tmp56_ = rect;
							_tmp57_ = rounded_rectangle_get_actor (_tmp56_);
							_tmp58_ = _tmp57_;
							clutter_actor_add_child (_tmp55_, _tmp58_);
							_tmp59_ = rect;
							_tmp60_ = rounded_rectangle_get_canvas (_tmp59_);
							_tmp61_ = _tmp60_;
							clutter_content_invalidate ((ClutterContent*) _tmp61_);
							_tmp62_ = rect;
							_tmp63_ = rounded_rectangle_get_actor (_tmp62_);
							_tmp64_ = _tmp63_;
							clutter_actor_show (_tmp64_);
							_tmp65_ = self->priv->_background;
							_tmp65__length1 = self->priv->_background_length1;
							_tmp65__length2 = self->priv->_background_length2;
							_tmp66_ = i;
							_tmp67_ = j;
							_tmp68_ = rect;
							_tmp69_ = _g_object_ref0 (_tmp68_);
							_g_object_unref0 (_tmp65_[(_tmp66_ * _tmp65__length2) + _tmp67_]);
							_tmp65_[(_tmp66_ * _tmp65__length2) + _tmp67_] = _tmp69_;
							_tmp70_ = _tmp65_[(_tmp66_ * _tmp65__length2) + _tmp67_];
							_g_object_unref0 (rect);
						}
					}
				}
			}
		}
	}
}


static void _game_resize_view (Game* self) {
	gint rows = 0;
	Grid* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint cols = 0;
	Grid* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gfloat canvas_width = 0.0F;
	ClutterActor* _tmp6_ = NULL;
	gfloat _tmp7_ = 0.0F;
	gfloat _tmp8_ = 0.0F;
	gfloat canvas_height = 0.0F;
	ClutterActor* _tmp9_ = NULL;
	gfloat _tmp10_ = 0.0F;
	gfloat _tmp11_ = 0.0F;
	gfloat _tmp12_ = 0.0F;
	gint _tmp13_ = 0;
	gint _tmp14_ = 0;
	gfloat _tmp15_ = 0.0F;
	gint _tmp16_ = 0;
	gint _tmp17_ = 0;
	gfloat tile_width = 0.0F;
	gfloat _tmp18_ = 0.0F;
	gint _tmp19_ = 0;
	gfloat tile_height = 0.0F;
	gfloat _tmp20_ = 0.0F;
	gint _tmp21_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_grid;
	_tmp1_ = grid_get_rows (_tmp0_);
	_tmp2_ = _tmp1_;
	rows = _tmp2_;
	_tmp3_ = self->priv->_grid;
	_tmp4_ = grid_get_cols (_tmp3_);
	_tmp5_ = _tmp4_;
	cols = _tmp5_;
	_tmp6_ = self->priv->_view;
	_tmp7_ = clutter_actor_get_width (_tmp6_);
	_tmp8_ = _tmp7_;
	canvas_width = _tmp8_;
	_tmp9_ = self->priv->_view;
	_tmp10_ = clutter_actor_get_height (_tmp9_);
	_tmp11_ = _tmp10_;
	canvas_height = _tmp11_;
	_tmp12_ = canvas_width;
	_tmp13_ = cols;
	_tmp14_ = self->priv->BLANK_COL_WIDTH;
	canvas_width = _tmp12_ - ((_tmp13_ + 1) * _tmp14_);
	_tmp15_ = canvas_height;
	_tmp16_ = rows;
	_tmp17_ = self->priv->BLANK_ROW_HEIGHT;
	canvas_height = _tmp15_ - ((_tmp16_ + 1) * _tmp17_);
	_tmp18_ = canvas_width;
	_tmp19_ = rows;
	tile_width = _tmp18_ / _tmp19_;
	_tmp20_ = canvas_height;
	_tmp21_ = cols;
	tile_height = _tmp20_ / _tmp21_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp22_ = FALSE;
			_tmp22_ = TRUE;
			while (TRUE) {
				gint _tmp24_ = 0;
				gint _tmp25_ = 0;
				if (!_tmp22_) {
					gint _tmp23_ = 0;
					_tmp23_ = i;
					i = _tmp23_ + 1;
				}
				_tmp22_ = FALSE;
				_tmp24_ = i;
				_tmp25_ = rows;
				if (!(_tmp24_ < _tmp25_)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp26_ = FALSE;
						_tmp26_ = TRUE;
						while (TRUE) {
							gint _tmp28_ = 0;
							gint _tmp29_ = 0;
							gfloat x = 0.0F;
							gint _tmp30_ = 0;
							gfloat _tmp31_ = 0.0F;
							gint _tmp32_ = 0;
							gint _tmp33_ = 0;
							gfloat y = 0.0F;
							gint _tmp34_ = 0;
							gfloat _tmp35_ = 0.0F;
							gint _tmp36_ = 0;
							gint _tmp37_ = 0;
							RoundedRectangle** _tmp38_ = NULL;
							gint _tmp38__length1 = 0;
							gint _tmp38__length2 = 0;
							gint _tmp39_ = 0;
							gint _tmp40_ = 0;
							RoundedRectangle* _tmp41_ = NULL;
							gfloat _tmp42_ = 0.0F;
							gfloat _tmp43_ = 0.0F;
							gfloat _tmp44_ = 0.0F;
							gfloat _tmp45_ = 0.0F;
							TileView** _tmp46_ = NULL;
							gint _tmp46__length1 = 0;
							gint _tmp46__length2 = 0;
							gint _tmp47_ = 0;
							gint _tmp48_ = 0;
							TileView* _tmp49_ = NULL;
							if (!_tmp26_) {
								gint _tmp27_ = 0;
								_tmp27_ = j;
								j = _tmp27_ + 1;
							}
							_tmp26_ = FALSE;
							_tmp28_ = j;
							_tmp29_ = cols;
							if (!(_tmp28_ < _tmp29_)) {
								break;
							}
							_tmp30_ = j;
							_tmp31_ = tile_width;
							_tmp32_ = j;
							_tmp33_ = self->priv->BLANK_COL_WIDTH;
							x = (_tmp30_ * _tmp31_) + ((_tmp32_ + 1) * _tmp33_);
							_tmp34_ = i;
							_tmp35_ = tile_height;
							_tmp36_ = i;
							_tmp37_ = self->priv->BLANK_ROW_HEIGHT;
							y = (_tmp34_ * _tmp35_) + ((_tmp36_ + 1) * _tmp37_);
							_tmp38_ = self->priv->_background;
							_tmp38__length1 = self->priv->_background_length1;
							_tmp38__length2 = self->priv->_background_length2;
							_tmp39_ = i;
							_tmp40_ = j;
							_tmp41_ = _tmp38_[(_tmp39_ * _tmp38__length2) + _tmp40_];
							_tmp42_ = x;
							_tmp43_ = y;
							_tmp44_ = tile_width;
							_tmp45_ = tile_height;
							rounded_rectangle_resize (_tmp41_, _tmp42_, _tmp43_, _tmp44_, _tmp45_);
							_tmp46_ = self->priv->_foreground_cur;
							_tmp46__length1 = self->priv->_foreground_cur_length1;
							_tmp46__length2 = self->priv->_foreground_cur_length2;
							_tmp47_ = i;
							_tmp48_ = j;
							_tmp49_ = _tmp46_[(_tmp47_ * _tmp46__length2) + _tmp48_];
							if (_tmp49_ != NULL) {
								TileView** _tmp50_ = NULL;
								gint _tmp50__length1 = 0;
								gint _tmp50__length2 = 0;
								gint _tmp51_ = 0;
								gint _tmp52_ = 0;
								TileView* _tmp53_ = NULL;
								gfloat _tmp54_ = 0.0F;
								gfloat _tmp55_ = 0.0F;
								gfloat _tmp56_ = 0.0F;
								gfloat _tmp57_ = 0.0F;
								_tmp50_ = self->priv->_foreground_cur;
								_tmp50__length1 = self->priv->_foreground_cur_length1;
								_tmp50__length2 = self->priv->_foreground_cur_length2;
								_tmp51_ = i;
								_tmp52_ = j;
								_tmp53_ = _tmp50_[(_tmp51_ * _tmp50__length2) + _tmp52_];
								_tmp54_ = x;
								_tmp55_ = y;
								_tmp56_ = tile_width;
								_tmp57_ = tile_height;
								rounded_rectangle_resize ((RoundedRectangle*) _tmp53_, _tmp54_, _tmp55_, _tmp56_, _tmp57_);
							}
						}
					}
				}
			}
		}
	}
}


static void _game_create_random_tile (Game* self) {
	Tile tile = {0};
	Grid* _tmp0_ = NULL;
	Tile _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_grid;
	_tmp2_ = grid_new_tile (_tmp0_, &_tmp1_);
	tile = _tmp1_;
	if (_tmp2_) {
		Tile _tmp3_ = {0};
		GeeLinkedList* _tmp4_ = NULL;
		Tile _tmp5_ = {0};
		Tile _tmp6_ = {0};
		GridPosition _tmp7_ = {0};
		ClutterTransitionGroup* _tmp8_ = NULL;
		_game_create_show_hide_transition (self);
		_tmp3_ = tile;
		_game_create_tile (self, &_tmp3_);
		_tmp4_ = self->priv->_to_show;
		_tmp5_ = tile;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, &_tmp5_);
		_tmp6_ = tile;
		_tmp7_ = _tmp6_.pos;
		_game_show_tile (self, &_tmp7_);
		_tmp8_ = self->priv->_show_hide_trans;
		clutter_timeline_start ((ClutterTimeline*) _tmp8_);
	}
}


static void _game_create_tile (Game* self, Tile* tile) {
	GridPosition pos = {0};
	RoundedRectangle* rect = NULL;
	TileView* view = NULL;
	gfloat x = 0.0F;
	gfloat y = 0.0F;
	gfloat width = 0.0F;
	gfloat height = 0.0F;
	Tile _tmp0_ = {0};
	GridPosition _tmp1_ = {0};
	RoundedRectangle** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	gint _tmp2__length2 = 0;
	GridPosition _tmp3_ = {0};
	guint _tmp4_ = 0U;
	GridPosition _tmp5_ = {0};
	guint _tmp6_ = 0U;
	RoundedRectangle* _tmp7_ = NULL;
	RoundedRectangle* _tmp8_ = NULL;
	ClutterActor* _tmp9_ = NULL;
	ClutterActor* _tmp10_ = NULL;
	gfloat _tmp11_ = 0.0F;
	gfloat _tmp12_ = 0.0F;
	ClutterActor* _tmp13_ = NULL;
	ClutterActor* _tmp14_ = NULL;
	gfloat _tmp15_ = 0.0F;
	gfloat _tmp16_ = 0.0F;
	ClutterActor* _tmp17_ = NULL;
	ClutterActor* _tmp18_ = NULL;
	gfloat _tmp19_ = 0.0F;
	gfloat _tmp20_ = 0.0F;
	ClutterActor* _tmp21_ = NULL;
	ClutterActor* _tmp22_ = NULL;
	gfloat _tmp23_ = 0.0F;
	gfloat _tmp24_ = 0.0F;
	TileView** _tmp25_ = NULL;
	gint _tmp25__length1 = 0;
	gint _tmp25__length2 = 0;
	GridPosition _tmp26_ = {0};
	guint _tmp27_ = 0U;
	GridPosition _tmp28_ = {0};
	guint _tmp29_ = 0U;
	TileView* _tmp30_ = NULL;
	Tile _tmp31_ = {0};
	guint _tmp32_ = 0U;
	TileView* _tmp33_ = NULL;
	TileView** _tmp34_ = NULL;
	gint _tmp34__length1 = 0;
	gint _tmp34__length2 = 0;
	GridPosition _tmp35_ = {0};
	guint _tmp36_ = 0U;
	GridPosition _tmp37_ = {0};
	guint _tmp38_ = 0U;
	TileView* _tmp39_ = NULL;
	TileView* _tmp40_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (tile != NULL);
	_tmp0_ = *tile;
	_tmp1_ = _tmp0_.pos;
	pos = _tmp1_;
	_tmp2_ = self->priv->_background;
	_tmp2__length1 = self->priv->_background_length1;
	_tmp2__length2 = self->priv->_background_length2;
	_tmp3_ = pos;
	_tmp4_ = _tmp3_.row;
	_tmp5_ = pos;
	_tmp6_ = _tmp5_.col;
	_tmp7_ = _tmp2_[(_tmp4_ * _tmp2__length2) + _tmp6_];
	_tmp8_ = _g_object_ref0 (_tmp7_);
	_g_object_unref0 (rect);
	rect = _tmp8_;
	_tmp9_ = rounded_rectangle_get_actor (rect);
	_tmp10_ = _tmp9_;
	_tmp11_ = clutter_actor_get_x (_tmp10_);
	_tmp12_ = _tmp11_;
	x = _tmp12_;
	_tmp13_ = rounded_rectangle_get_actor (rect);
	_tmp14_ = _tmp13_;
	_tmp15_ = clutter_actor_get_y (_tmp14_);
	_tmp16_ = _tmp15_;
	y = _tmp16_;
	_tmp17_ = rounded_rectangle_get_actor (rect);
	_tmp18_ = _tmp17_;
	_tmp19_ = clutter_actor_get_width (_tmp18_);
	_tmp20_ = _tmp19_;
	width = _tmp20_;
	_tmp21_ = rounded_rectangle_get_actor (rect);
	_tmp22_ = _tmp21_;
	_tmp23_ = clutter_actor_get_height (_tmp22_);
	_tmp24_ = _tmp23_;
	height = _tmp24_;
	_tmp25_ = self->priv->_foreground_nxt;
	_tmp25__length1 = self->priv->_foreground_nxt_length1;
	_tmp25__length2 = self->priv->_foreground_nxt_length2;
	_tmp26_ = pos;
	_tmp27_ = _tmp26_.row;
	_tmp28_ = pos;
	_tmp29_ = _tmp28_.col;
	_tmp30_ = _tmp25_[(_tmp27_ * _tmp25__length2) + _tmp29_];
	_vala_assert (_tmp30_ == NULL, "_foreground_nxt[pos.row,pos.col] == null");
	_tmp31_ = *tile;
	_tmp32_ = _tmp31_.val;
	_tmp33_ = tile_view_new (x, y, width, height, _tmp32_);
	_g_object_unref0 (view);
	view = _tmp33_;
	_tmp34_ = self->priv->_foreground_nxt;
	_tmp34__length1 = self->priv->_foreground_nxt_length1;
	_tmp34__length2 = self->priv->_foreground_nxt_length2;
	_tmp35_ = pos;
	_tmp36_ = _tmp35_.row;
	_tmp37_ = pos;
	_tmp38_ = _tmp37_.col;
	_tmp39_ = _g_object_ref0 (view);
	_g_object_unref0 (_tmp34_[(_tmp36_ * _tmp34__length2) + _tmp38_]);
	_tmp34_[(_tmp36_ * _tmp34__length2) + _tmp38_] = _tmp39_;
	_tmp40_ = _tmp34_[(_tmp36_ * _tmp34__length2) + _tmp38_];
	_g_object_unref0 (view);
	_g_object_unref0 (rect);
}


static void __game_on_move_trans_stopped_clutter_timeline_stopped (ClutterTimeline* _sender, gboolean is_finished, gpointer self) {
	_game_on_move_trans_stopped ((Game*) self, is_finished);
}


static void _game_move_down (Game* self) {
	gboolean has_moved = FALSE;
	ClutterTransitionGroup* _tmp0_ = NULL;
	ClutterTransitionGroup* _tmp1_ = NULL;
	ClutterTransitionGroup* _tmp2_ = NULL;
	Grid* _tmp3_ = NULL;
	GeeLinkedList* _tmp4_ = NULL;
	GeeLinkedList* _tmp5_ = NULL;
	GeeLinkedList* _tmp6_ = NULL;
	gboolean _tmp37_ = FALSE;
	gboolean _tmp38_ = FALSE;
	GeeLinkedList* _tmp39_ = NULL;
	gint _tmp40_ = 0;
	gint _tmp41_ = 0;
	gboolean _tmp48_ = FALSE;
	g_return_if_fail (self != NULL);
	g_debug ("game.vala:295: move down");
	_tmp0_ = (ClutterTransitionGroup*) clutter_transition_group_new ();
	_g_object_unref0 (self->priv->_move_trans);
	self->priv->_move_trans = _tmp0_;
	_tmp1_ = self->priv->_move_trans;
	g_signal_connect_object ((ClutterTimeline*) _tmp1_, "stopped", (GCallback) __game_on_move_trans_stopped_clutter_timeline_stopped, self, 0);
	_tmp2_ = self->priv->_move_trans;
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp2_, (guint) 100);
	_tmp3_ = self->priv->_grid;
	_tmp4_ = self->priv->_to_move;
	_tmp5_ = self->priv->_to_hide;
	_tmp6_ = self->priv->_to_show;
	grid_move_down (_tmp3_, _tmp4_, _tmp5_, _tmp6_);
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp7_ = NULL;
		GeeLinkedList* _tmp8_ = NULL;
		gint _e_size = 0;
		GeeLinkedList* _tmp9_ = NULL;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		gint _e_index = 0;
		_tmp7_ = self->priv->_to_move;
		_tmp8_ = _g_object_ref0 (_tmp7_);
		_e_list = _tmp8_;
		_tmp9_ = _e_list;
		_tmp10_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp9_);
		_tmp11_ = _tmp10_;
		_e_size = _tmp11_;
		_e_index = -1;
		while (TRUE) {
			gint _tmp12_ = 0;
			gint _tmp13_ = 0;
			gint _tmp14_ = 0;
			TileMovement* e = NULL;
			GeeLinkedList* _tmp15_ = NULL;
			gint _tmp16_ = 0;
			gpointer _tmp17_ = NULL;
			TileMovement* _tmp18_ = NULL;
			GridPosition _tmp19_ = {0};
			TileMovement* _tmp20_ = NULL;
			GridPosition _tmp21_ = {0};
			_tmp12_ = _e_index;
			_e_index = _tmp12_ + 1;
			_tmp13_ = _e_index;
			_tmp14_ = _e_size;
			if (!(_tmp13_ < _tmp14_)) {
				break;
			}
			_tmp15_ = _e_list;
			_tmp16_ = _e_index;
			_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, _tmp16_);
			e = (TileMovement*) _tmp17_;
			_tmp18_ = e;
			_tmp19_ = (*_tmp18_).from;
			_tmp20_ = e;
			_tmp21_ = (*_tmp20_).to;
			_game_move_tile (self, &_tmp19_, &_tmp21_);
			_tile_movement_free0 (e);
		}
		_g_object_unref0 (_e_list);
	}
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp22_ = NULL;
		GeeLinkedList* _tmp23_ = NULL;
		gint _e_size = 0;
		GeeLinkedList* _tmp24_ = NULL;
		gint _tmp25_ = 0;
		gint _tmp26_ = 0;
		gint _e_index = 0;
		_tmp22_ = self->priv->_to_hide;
		_tmp23_ = _g_object_ref0 (_tmp22_);
		_e_list = _tmp23_;
		_tmp24_ = _e_list;
		_tmp25_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp24_);
		_tmp26_ = _tmp25_;
		_e_size = _tmp26_;
		_e_index = -1;
		while (TRUE) {
			gint _tmp27_ = 0;
			gint _tmp28_ = 0;
			gint _tmp29_ = 0;
			TileMovement* e = NULL;
			GeeLinkedList* _tmp30_ = NULL;
			gint _tmp31_ = 0;
			gpointer _tmp32_ = NULL;
			TileMovement* _tmp33_ = NULL;
			GridPosition _tmp34_ = {0};
			TileMovement* _tmp35_ = NULL;
			GridPosition _tmp36_ = {0};
			_tmp27_ = _e_index;
			_e_index = _tmp27_ + 1;
			_tmp28_ = _e_index;
			_tmp29_ = _e_size;
			if (!(_tmp28_ < _tmp29_)) {
				break;
			}
			_tmp30_ = _e_list;
			_tmp31_ = _e_index;
			_tmp32_ = gee_abstract_list_get ((GeeAbstractList*) _tmp30_, _tmp31_);
			e = (TileMovement*) _tmp32_;
			_tmp33_ = e;
			_tmp34_ = (*_tmp33_).from;
			_tmp35_ = e;
			_tmp36_ = (*_tmp35_).to;
			_game_prepare_move_tile (self, &_tmp34_, &_tmp36_);
			_tile_movement_free0 (e);
		}
		_g_object_unref0 (_e_list);
	}
	_tmp39_ = self->priv->_to_move;
	_tmp40_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp39_);
	_tmp41_ = _tmp40_;
	if (_tmp41_ > 0) {
		_tmp38_ = TRUE;
	} else {
		GeeLinkedList* _tmp42_ = NULL;
		gint _tmp43_ = 0;
		gint _tmp44_ = 0;
		_tmp42_ = self->priv->_to_hide;
		_tmp43_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp42_);
		_tmp44_ = _tmp43_;
		_tmp38_ = _tmp44_ > 0;
	}
	if (_tmp38_) {
		_tmp37_ = TRUE;
	} else {
		GeeLinkedList* _tmp45_ = NULL;
		gint _tmp46_ = 0;
		gint _tmp47_ = 0;
		_tmp45_ = self->priv->_to_show;
		_tmp46_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp45_);
		_tmp47_ = _tmp46_;
		_tmp37_ = _tmp47_ > 0;
	}
	has_moved = _tmp37_;
	_tmp48_ = has_moved;
	if (_tmp48_) {
		ClutterTransitionGroup* _tmp49_ = NULL;
		self->priv->_state = GAME_GAME_STATE_MOVING_DOWN;
		_tmp49_ = self->priv->_move_trans;
		clutter_timeline_start ((ClutterTimeline*) _tmp49_);
	}
}


static void _game_move_up (Game* self) {
	gboolean has_moved = FALSE;
	ClutterTransitionGroup* _tmp0_ = NULL;
	ClutterTransitionGroup* _tmp1_ = NULL;
	ClutterTransitionGroup* _tmp2_ = NULL;
	Grid* _tmp3_ = NULL;
	GeeLinkedList* _tmp4_ = NULL;
	GeeLinkedList* _tmp5_ = NULL;
	GeeLinkedList* _tmp6_ = NULL;
	gboolean _tmp37_ = FALSE;
	gboolean _tmp38_ = FALSE;
	GeeLinkedList* _tmp39_ = NULL;
	gint _tmp40_ = 0;
	gint _tmp41_ = 0;
	gboolean _tmp48_ = FALSE;
	g_return_if_fail (self != NULL);
	g_debug ("game.vala:321: move up");
	_tmp0_ = (ClutterTransitionGroup*) clutter_transition_group_new ();
	_g_object_unref0 (self->priv->_move_trans);
	self->priv->_move_trans = _tmp0_;
	_tmp1_ = self->priv->_move_trans;
	g_signal_connect_object ((ClutterTimeline*) _tmp1_, "stopped", (GCallback) __game_on_move_trans_stopped_clutter_timeline_stopped, self, 0);
	_tmp2_ = self->priv->_move_trans;
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp2_, (guint) 100);
	_tmp3_ = self->priv->_grid;
	_tmp4_ = self->priv->_to_move;
	_tmp5_ = self->priv->_to_hide;
	_tmp6_ = self->priv->_to_show;
	grid_move_up (_tmp3_, _tmp4_, _tmp5_, _tmp6_);
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp7_ = NULL;
		GeeLinkedList* _tmp8_ = NULL;
		gint _e_size = 0;
		GeeLinkedList* _tmp9_ = NULL;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		gint _e_index = 0;
		_tmp7_ = self->priv->_to_move;
		_tmp8_ = _g_object_ref0 (_tmp7_);
		_e_list = _tmp8_;
		_tmp9_ = _e_list;
		_tmp10_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp9_);
		_tmp11_ = _tmp10_;
		_e_size = _tmp11_;
		_e_index = -1;
		while (TRUE) {
			gint _tmp12_ = 0;
			gint _tmp13_ = 0;
			gint _tmp14_ = 0;
			TileMovement* e = NULL;
			GeeLinkedList* _tmp15_ = NULL;
			gint _tmp16_ = 0;
			gpointer _tmp17_ = NULL;
			TileMovement* _tmp18_ = NULL;
			GridPosition _tmp19_ = {0};
			TileMovement* _tmp20_ = NULL;
			GridPosition _tmp21_ = {0};
			_tmp12_ = _e_index;
			_e_index = _tmp12_ + 1;
			_tmp13_ = _e_index;
			_tmp14_ = _e_size;
			if (!(_tmp13_ < _tmp14_)) {
				break;
			}
			_tmp15_ = _e_list;
			_tmp16_ = _e_index;
			_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, _tmp16_);
			e = (TileMovement*) _tmp17_;
			_tmp18_ = e;
			_tmp19_ = (*_tmp18_).from;
			_tmp20_ = e;
			_tmp21_ = (*_tmp20_).to;
			_game_move_tile (self, &_tmp19_, &_tmp21_);
			_tile_movement_free0 (e);
		}
		_g_object_unref0 (_e_list);
	}
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp22_ = NULL;
		GeeLinkedList* _tmp23_ = NULL;
		gint _e_size = 0;
		GeeLinkedList* _tmp24_ = NULL;
		gint _tmp25_ = 0;
		gint _tmp26_ = 0;
		gint _e_index = 0;
		_tmp22_ = self->priv->_to_hide;
		_tmp23_ = _g_object_ref0 (_tmp22_);
		_e_list = _tmp23_;
		_tmp24_ = _e_list;
		_tmp25_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp24_);
		_tmp26_ = _tmp25_;
		_e_size = _tmp26_;
		_e_index = -1;
		while (TRUE) {
			gint _tmp27_ = 0;
			gint _tmp28_ = 0;
			gint _tmp29_ = 0;
			TileMovement* e = NULL;
			GeeLinkedList* _tmp30_ = NULL;
			gint _tmp31_ = 0;
			gpointer _tmp32_ = NULL;
			TileMovement* _tmp33_ = NULL;
			GridPosition _tmp34_ = {0};
			TileMovement* _tmp35_ = NULL;
			GridPosition _tmp36_ = {0};
			_tmp27_ = _e_index;
			_e_index = _tmp27_ + 1;
			_tmp28_ = _e_index;
			_tmp29_ = _e_size;
			if (!(_tmp28_ < _tmp29_)) {
				break;
			}
			_tmp30_ = _e_list;
			_tmp31_ = _e_index;
			_tmp32_ = gee_abstract_list_get ((GeeAbstractList*) _tmp30_, _tmp31_);
			e = (TileMovement*) _tmp32_;
			_tmp33_ = e;
			_tmp34_ = (*_tmp33_).from;
			_tmp35_ = e;
			_tmp36_ = (*_tmp35_).to;
			_game_prepare_move_tile (self, &_tmp34_, &_tmp36_);
			_tile_movement_free0 (e);
		}
		_g_object_unref0 (_e_list);
	}
	_tmp39_ = self->priv->_to_move;
	_tmp40_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp39_);
	_tmp41_ = _tmp40_;
	if (_tmp41_ > 0) {
		_tmp38_ = TRUE;
	} else {
		GeeLinkedList* _tmp42_ = NULL;
		gint _tmp43_ = 0;
		gint _tmp44_ = 0;
		_tmp42_ = self->priv->_to_hide;
		_tmp43_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp42_);
		_tmp44_ = _tmp43_;
		_tmp38_ = _tmp44_ > 0;
	}
	if (_tmp38_) {
		_tmp37_ = TRUE;
	} else {
		GeeLinkedList* _tmp45_ = NULL;
		gint _tmp46_ = 0;
		gint _tmp47_ = 0;
		_tmp45_ = self->priv->_to_show;
		_tmp46_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp45_);
		_tmp47_ = _tmp46_;
		_tmp37_ = _tmp47_ > 0;
	}
	has_moved = _tmp37_;
	_tmp48_ = has_moved;
	if (_tmp48_) {
		ClutterTransitionGroup* _tmp49_ = NULL;
		self->priv->_state = GAME_GAME_STATE_MOVING_UP;
		_tmp49_ = self->priv->_move_trans;
		clutter_timeline_start ((ClutterTimeline*) _tmp49_);
	}
}


static void _game_move_left (Game* self) {
	gboolean has_moved = FALSE;
	ClutterTransitionGroup* _tmp0_ = NULL;
	ClutterTransitionGroup* _tmp1_ = NULL;
	ClutterTransitionGroup* _tmp2_ = NULL;
	Grid* _tmp3_ = NULL;
	GeeLinkedList* _tmp4_ = NULL;
	GeeLinkedList* _tmp5_ = NULL;
	GeeLinkedList* _tmp6_ = NULL;
	gboolean _tmp37_ = FALSE;
	gboolean _tmp38_ = FALSE;
	GeeLinkedList* _tmp39_ = NULL;
	gint _tmp40_ = 0;
	gint _tmp41_ = 0;
	gboolean _tmp48_ = FALSE;
	g_return_if_fail (self != NULL);
	g_debug ("game.vala:347: move left");
	_tmp0_ = (ClutterTransitionGroup*) clutter_transition_group_new ();
	_g_object_unref0 (self->priv->_move_trans);
	self->priv->_move_trans = _tmp0_;
	_tmp1_ = self->priv->_move_trans;
	g_signal_connect_object ((ClutterTimeline*) _tmp1_, "stopped", (GCallback) __game_on_move_trans_stopped_clutter_timeline_stopped, self, 0);
	_tmp2_ = self->priv->_move_trans;
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp2_, (guint) 100);
	_tmp3_ = self->priv->_grid;
	_tmp4_ = self->priv->_to_move;
	_tmp5_ = self->priv->_to_hide;
	_tmp6_ = self->priv->_to_show;
	grid_move_left (_tmp3_, _tmp4_, _tmp5_, _tmp6_);
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp7_ = NULL;
		GeeLinkedList* _tmp8_ = NULL;
		gint _e_size = 0;
		GeeLinkedList* _tmp9_ = NULL;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		gint _e_index = 0;
		_tmp7_ = self->priv->_to_move;
		_tmp8_ = _g_object_ref0 (_tmp7_);
		_e_list = _tmp8_;
		_tmp9_ = _e_list;
		_tmp10_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp9_);
		_tmp11_ = _tmp10_;
		_e_size = _tmp11_;
		_e_index = -1;
		while (TRUE) {
			gint _tmp12_ = 0;
			gint _tmp13_ = 0;
			gint _tmp14_ = 0;
			TileMovement* e = NULL;
			GeeLinkedList* _tmp15_ = NULL;
			gint _tmp16_ = 0;
			gpointer _tmp17_ = NULL;
			TileMovement* _tmp18_ = NULL;
			GridPosition _tmp19_ = {0};
			TileMovement* _tmp20_ = NULL;
			GridPosition _tmp21_ = {0};
			_tmp12_ = _e_index;
			_e_index = _tmp12_ + 1;
			_tmp13_ = _e_index;
			_tmp14_ = _e_size;
			if (!(_tmp13_ < _tmp14_)) {
				break;
			}
			_tmp15_ = _e_list;
			_tmp16_ = _e_index;
			_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, _tmp16_);
			e = (TileMovement*) _tmp17_;
			_tmp18_ = e;
			_tmp19_ = (*_tmp18_).from;
			_tmp20_ = e;
			_tmp21_ = (*_tmp20_).to;
			_game_move_tile (self, &_tmp19_, &_tmp21_);
			_tile_movement_free0 (e);
		}
		_g_object_unref0 (_e_list);
	}
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp22_ = NULL;
		GeeLinkedList* _tmp23_ = NULL;
		gint _e_size = 0;
		GeeLinkedList* _tmp24_ = NULL;
		gint _tmp25_ = 0;
		gint _tmp26_ = 0;
		gint _e_index = 0;
		_tmp22_ = self->priv->_to_hide;
		_tmp23_ = _g_object_ref0 (_tmp22_);
		_e_list = _tmp23_;
		_tmp24_ = _e_list;
		_tmp25_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp24_);
		_tmp26_ = _tmp25_;
		_e_size = _tmp26_;
		_e_index = -1;
		while (TRUE) {
			gint _tmp27_ = 0;
			gint _tmp28_ = 0;
			gint _tmp29_ = 0;
			TileMovement* e = NULL;
			GeeLinkedList* _tmp30_ = NULL;
			gint _tmp31_ = 0;
			gpointer _tmp32_ = NULL;
			TileMovement* _tmp33_ = NULL;
			GridPosition _tmp34_ = {0};
			TileMovement* _tmp35_ = NULL;
			GridPosition _tmp36_ = {0};
			_tmp27_ = _e_index;
			_e_index = _tmp27_ + 1;
			_tmp28_ = _e_index;
			_tmp29_ = _e_size;
			if (!(_tmp28_ < _tmp29_)) {
				break;
			}
			_tmp30_ = _e_list;
			_tmp31_ = _e_index;
			_tmp32_ = gee_abstract_list_get ((GeeAbstractList*) _tmp30_, _tmp31_);
			e = (TileMovement*) _tmp32_;
			_tmp33_ = e;
			_tmp34_ = (*_tmp33_).from;
			_tmp35_ = e;
			_tmp36_ = (*_tmp35_).to;
			_game_prepare_move_tile (self, &_tmp34_, &_tmp36_);
			_tile_movement_free0 (e);
		}
		_g_object_unref0 (_e_list);
	}
	_tmp39_ = self->priv->_to_move;
	_tmp40_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp39_);
	_tmp41_ = _tmp40_;
	if (_tmp41_ > 0) {
		_tmp38_ = TRUE;
	} else {
		GeeLinkedList* _tmp42_ = NULL;
		gint _tmp43_ = 0;
		gint _tmp44_ = 0;
		_tmp42_ = self->priv->_to_hide;
		_tmp43_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp42_);
		_tmp44_ = _tmp43_;
		_tmp38_ = _tmp44_ > 0;
	}
	if (_tmp38_) {
		_tmp37_ = TRUE;
	} else {
		GeeLinkedList* _tmp45_ = NULL;
		gint _tmp46_ = 0;
		gint _tmp47_ = 0;
		_tmp45_ = self->priv->_to_show;
		_tmp46_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp45_);
		_tmp47_ = _tmp46_;
		_tmp37_ = _tmp47_ > 0;
	}
	has_moved = _tmp37_;
	_tmp48_ = has_moved;
	if (_tmp48_) {
		ClutterTransitionGroup* _tmp49_ = NULL;
		self->priv->_state = GAME_GAME_STATE_MOVING_LEFT;
		_tmp49_ = self->priv->_move_trans;
		clutter_timeline_start ((ClutterTimeline*) _tmp49_);
	}
}


static void _game_move_right (Game* self) {
	gboolean has_moved = FALSE;
	ClutterTransitionGroup* _tmp0_ = NULL;
	ClutterTransitionGroup* _tmp1_ = NULL;
	ClutterTransitionGroup* _tmp2_ = NULL;
	Grid* _tmp3_ = NULL;
	GeeLinkedList* _tmp4_ = NULL;
	GeeLinkedList* _tmp5_ = NULL;
	GeeLinkedList* _tmp6_ = NULL;
	gboolean _tmp37_ = FALSE;
	gboolean _tmp38_ = FALSE;
	GeeLinkedList* _tmp39_ = NULL;
	gint _tmp40_ = 0;
	gint _tmp41_ = 0;
	gboolean _tmp48_ = FALSE;
	g_return_if_fail (self != NULL);
	g_debug ("game.vala:373: move right");
	_tmp0_ = (ClutterTransitionGroup*) clutter_transition_group_new ();
	_g_object_unref0 (self->priv->_move_trans);
	self->priv->_move_trans = _tmp0_;
	_tmp1_ = self->priv->_move_trans;
	g_signal_connect_object ((ClutterTimeline*) _tmp1_, "stopped", (GCallback) __game_on_move_trans_stopped_clutter_timeline_stopped, self, 0);
	_tmp2_ = self->priv->_move_trans;
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp2_, (guint) 100);
	_tmp3_ = self->priv->_grid;
	_tmp4_ = self->priv->_to_move;
	_tmp5_ = self->priv->_to_hide;
	_tmp6_ = self->priv->_to_show;
	grid_move_right (_tmp3_, _tmp4_, _tmp5_, _tmp6_);
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp7_ = NULL;
		GeeLinkedList* _tmp8_ = NULL;
		gint _e_size = 0;
		GeeLinkedList* _tmp9_ = NULL;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		gint _e_index = 0;
		_tmp7_ = self->priv->_to_move;
		_tmp8_ = _g_object_ref0 (_tmp7_);
		_e_list = _tmp8_;
		_tmp9_ = _e_list;
		_tmp10_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp9_);
		_tmp11_ = _tmp10_;
		_e_size = _tmp11_;
		_e_index = -1;
		while (TRUE) {
			gint _tmp12_ = 0;
			gint _tmp13_ = 0;
			gint _tmp14_ = 0;
			TileMovement* e = NULL;
			GeeLinkedList* _tmp15_ = NULL;
			gint _tmp16_ = 0;
			gpointer _tmp17_ = NULL;
			TileMovement* _tmp18_ = NULL;
			GridPosition _tmp19_ = {0};
			TileMovement* _tmp20_ = NULL;
			GridPosition _tmp21_ = {0};
			_tmp12_ = _e_index;
			_e_index = _tmp12_ + 1;
			_tmp13_ = _e_index;
			_tmp14_ = _e_size;
			if (!(_tmp13_ < _tmp14_)) {
				break;
			}
			_tmp15_ = _e_list;
			_tmp16_ = _e_index;
			_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, _tmp16_);
			e = (TileMovement*) _tmp17_;
			_tmp18_ = e;
			_tmp19_ = (*_tmp18_).from;
			_tmp20_ = e;
			_tmp21_ = (*_tmp20_).to;
			_game_move_tile (self, &_tmp19_, &_tmp21_);
			_tile_movement_free0 (e);
		}
		_g_object_unref0 (_e_list);
	}
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp22_ = NULL;
		GeeLinkedList* _tmp23_ = NULL;
		gint _e_size = 0;
		GeeLinkedList* _tmp24_ = NULL;
		gint _tmp25_ = 0;
		gint _tmp26_ = 0;
		gint _e_index = 0;
		_tmp22_ = self->priv->_to_hide;
		_tmp23_ = _g_object_ref0 (_tmp22_);
		_e_list = _tmp23_;
		_tmp24_ = _e_list;
		_tmp25_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp24_);
		_tmp26_ = _tmp25_;
		_e_size = _tmp26_;
		_e_index = -1;
		while (TRUE) {
			gint _tmp27_ = 0;
			gint _tmp28_ = 0;
			gint _tmp29_ = 0;
			TileMovement* e = NULL;
			GeeLinkedList* _tmp30_ = NULL;
			gint _tmp31_ = 0;
			gpointer _tmp32_ = NULL;
			TileMovement* _tmp33_ = NULL;
			GridPosition _tmp34_ = {0};
			TileMovement* _tmp35_ = NULL;
			GridPosition _tmp36_ = {0};
			_tmp27_ = _e_index;
			_e_index = _tmp27_ + 1;
			_tmp28_ = _e_index;
			_tmp29_ = _e_size;
			if (!(_tmp28_ < _tmp29_)) {
				break;
			}
			_tmp30_ = _e_list;
			_tmp31_ = _e_index;
			_tmp32_ = gee_abstract_list_get ((GeeAbstractList*) _tmp30_, _tmp31_);
			e = (TileMovement*) _tmp32_;
			_tmp33_ = e;
			_tmp34_ = (*_tmp33_).from;
			_tmp35_ = e;
			_tmp36_ = (*_tmp35_).to;
			_game_prepare_move_tile (self, &_tmp34_, &_tmp36_);
			_tile_movement_free0 (e);
		}
		_g_object_unref0 (_e_list);
	}
	_tmp39_ = self->priv->_to_move;
	_tmp40_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp39_);
	_tmp41_ = _tmp40_;
	if (_tmp41_ > 0) {
		_tmp38_ = TRUE;
	} else {
		GeeLinkedList* _tmp42_ = NULL;
		gint _tmp43_ = 0;
		gint _tmp44_ = 0;
		_tmp42_ = self->priv->_to_hide;
		_tmp43_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp42_);
		_tmp44_ = _tmp43_;
		_tmp38_ = _tmp44_ > 0;
	}
	if (_tmp38_) {
		_tmp37_ = TRUE;
	} else {
		GeeLinkedList* _tmp45_ = NULL;
		gint _tmp46_ = 0;
		gint _tmp47_ = 0;
		_tmp45_ = self->priv->_to_show;
		_tmp46_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp45_);
		_tmp47_ = _tmp46_;
		_tmp37_ = _tmp47_ > 0;
	}
	has_moved = _tmp37_;
	_tmp48_ = has_moved;
	if (_tmp48_) {
		ClutterTransitionGroup* _tmp49_ = NULL;
		self->priv->_state = GAME_GAME_STATE_MOVING_LEFT;
		_tmp49_ = self->priv->_move_trans;
		clutter_timeline_start ((ClutterTimeline*) _tmp49_);
	}
}


static void _game_show_tile (Game* self, GridPosition* pos) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	ClutterPropertyTransition* trans = NULL;
	TileView* view = NULL;
	TileView** _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	gint _tmp4__length2 = 0;
	GridPosition _tmp5_ = {0};
	guint _tmp6_ = 0U;
	GridPosition _tmp7_ = {0};
	guint _tmp8_ = 0U;
	TileView* _tmp9_ = NULL;
	TileView* _tmp10_ = NULL;
	ClutterCanvas* _tmp11_ = NULL;
	ClutterCanvas* _tmp12_ = NULL;
	ClutterActor* _tmp13_ = NULL;
	ClutterActor* _tmp14_ = NULL;
	ClutterActor* _tmp15_ = NULL;
	ClutterActor* _tmp16_ = NULL;
	ClutterActor* _tmp17_ = NULL;
	ClutterActor* _tmp18_ = NULL;
	ClutterActor* _tmp19_ = NULL;
	ClutterPropertyTransition* _tmp20_ = NULL;
	ClutterPropertyTransition* _tmp21_ = NULL;
	GValue _tmp22_ = {0};
	ClutterPropertyTransition* _tmp23_ = NULL;
	GValue _tmp24_ = {0};
	ClutterPropertyTransition* _tmp25_ = NULL;
	ClutterPropertyTransition* _tmp26_ = NULL;
	ClutterActor* _tmp27_ = NULL;
	ClutterActor* _tmp28_ = NULL;
	ClutterTransitionGroup* _tmp29_ = NULL;
	ClutterPropertyTransition* _tmp30_ = NULL;
	ClutterPropertyTransition* _tmp31_ = NULL;
	ClutterPropertyTransition* _tmp32_ = NULL;
	GValue _tmp33_ = {0};
	ClutterPropertyTransition* _tmp34_ = NULL;
	GValue _tmp35_ = {0};
	ClutterPropertyTransition* _tmp36_ = NULL;
	ClutterPropertyTransition* _tmp37_ = NULL;
	ClutterActor* _tmp38_ = NULL;
	ClutterActor* _tmp39_ = NULL;
	ClutterTransitionGroup* _tmp40_ = NULL;
	ClutterPropertyTransition* _tmp41_ = NULL;
	ClutterPropertyTransition* _tmp42_ = NULL;
	ClutterPropertyTransition* _tmp43_ = NULL;
	GValue _tmp44_ = {0};
	ClutterPropertyTransition* _tmp45_ = NULL;
	GValue _tmp46_ = {0};
	ClutterPropertyTransition* _tmp47_ = NULL;
	ClutterPropertyTransition* _tmp48_ = NULL;
	ClutterActor* _tmp49_ = NULL;
	ClutterActor* _tmp50_ = NULL;
	ClutterPropertyTransition* _tmp51_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (pos != NULL);
	_tmp0_ = grid_position_to_string (pos);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strconcat ("show tile pos ", _tmp1_, NULL);
	_tmp3_ = _tmp2_;
	g_debug ("game.vala:399: %s", _tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	_tmp4_ = self->priv->_foreground_nxt;
	_tmp4__length1 = self->priv->_foreground_nxt_length1;
	_tmp4__length2 = self->priv->_foreground_nxt_length2;
	_tmp5_ = *pos;
	_tmp6_ = _tmp5_.row;
	_tmp7_ = *pos;
	_tmp8_ = _tmp7_.col;
	_tmp9_ = _tmp4_[(_tmp6_ * _tmp4__length2) + _tmp8_];
	_tmp10_ = _g_object_ref0 (_tmp9_);
	_g_object_unref0 (view);
	view = _tmp10_;
	_tmp11_ = rounded_rectangle_get_canvas ((RoundedRectangle*) view);
	_tmp12_ = _tmp11_;
	clutter_content_invalidate ((ClutterContent*) _tmp12_);
	_tmp13_ = rounded_rectangle_get_actor ((RoundedRectangle*) view);
	_tmp14_ = _tmp13_;
	clutter_actor_set_opacity (_tmp14_, (guint8) 0);
	_tmp15_ = rounded_rectangle_get_actor ((RoundedRectangle*) view);
	_tmp16_ = _tmp15_;
	clutter_actor_show (_tmp16_);
	_tmp17_ = self->priv->_view;
	_tmp18_ = rounded_rectangle_get_actor ((RoundedRectangle*) view);
	_tmp19_ = _tmp18_;
	clutter_actor_add_child (_tmp17_, _tmp19_);
	_tmp20_ = (ClutterPropertyTransition*) clutter_property_transition_new ("scale-x");
	_g_object_unref0 (trans);
	trans = _tmp20_;
	_tmp21_ = trans;
	g_value_init (&_tmp22_, G_TYPE_DOUBLE);
	g_value_set_double (&_tmp22_, 1.0);
	clutter_transition_set_from_value ((ClutterTransition*) _tmp21_, &_tmp22_);
	G_IS_VALUE (&_tmp22_) ? (g_value_unset (&_tmp22_), NULL) : NULL;
	_tmp23_ = trans;
	g_value_init (&_tmp24_, G_TYPE_DOUBLE);
	g_value_set_double (&_tmp24_, 1.1);
	clutter_transition_set_to_value ((ClutterTransition*) _tmp23_, &_tmp24_);
	G_IS_VALUE (&_tmp24_) ? (g_value_unset (&_tmp24_), NULL) : NULL;
	_tmp25_ = trans;
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp25_, (guint) 100);
	_tmp26_ = trans;
	_tmp27_ = rounded_rectangle_get_actor ((RoundedRectangle*) view);
	_tmp28_ = _tmp27_;
	clutter_transition_set_animatable ((ClutterTransition*) _tmp26_, (ClutterAnimatable*) _tmp28_);
	_tmp29_ = self->priv->_show_hide_trans;
	_tmp30_ = trans;
	clutter_transition_group_add_transition (_tmp29_, (ClutterTransition*) _tmp30_);
	_tmp31_ = (ClutterPropertyTransition*) clutter_property_transition_new ("scale-y");
	_g_object_unref0 (trans);
	trans = _tmp31_;
	_tmp32_ = trans;
	g_value_init (&_tmp33_, G_TYPE_DOUBLE);
	g_value_set_double (&_tmp33_, 1.0);
	clutter_transition_set_from_value ((ClutterTransition*) _tmp32_, &_tmp33_);
	G_IS_VALUE (&_tmp33_) ? (g_value_unset (&_tmp33_), NULL) : NULL;
	_tmp34_ = trans;
	g_value_init (&_tmp35_, G_TYPE_DOUBLE);
	g_value_set_double (&_tmp35_, 1.1);
	clutter_transition_set_to_value ((ClutterTransition*) _tmp34_, &_tmp35_);
	G_IS_VALUE (&_tmp35_) ? (g_value_unset (&_tmp35_), NULL) : NULL;
	_tmp36_ = trans;
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp36_, (guint) 100);
	_tmp37_ = trans;
	_tmp38_ = rounded_rectangle_get_actor ((RoundedRectangle*) view);
	_tmp39_ = _tmp38_;
	clutter_transition_set_animatable ((ClutterTransition*) _tmp37_, (ClutterAnimatable*) _tmp39_);
	_tmp40_ = self->priv->_show_hide_trans;
	_tmp41_ = trans;
	clutter_transition_group_add_transition (_tmp40_, (ClutterTransition*) _tmp41_);
	_tmp42_ = (ClutterPropertyTransition*) clutter_property_transition_new ("opacity");
	_g_object_unref0 (trans);
	trans = _tmp42_;
	_tmp43_ = trans;
	g_value_init (&_tmp44_, G_TYPE_INT);
	g_value_set_int (&_tmp44_, 0);
	clutter_transition_set_from_value ((ClutterTransition*) _tmp43_, &_tmp44_);
	G_IS_VALUE (&_tmp44_) ? (g_value_unset (&_tmp44_), NULL) : NULL;
	_tmp45_ = trans;
	g_value_init (&_tmp46_, G_TYPE_INT);
	g_value_set_int (&_tmp46_, 255);
	clutter_transition_set_to_value ((ClutterTransition*) _tmp45_, &_tmp46_);
	G_IS_VALUE (&_tmp46_) ? (g_value_unset (&_tmp46_), NULL) : NULL;
	_tmp47_ = trans;
	clutter_transition_set_remove_on_complete ((ClutterTransition*) _tmp47_, TRUE);
	_tmp48_ = trans;
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp48_, (guint) 50);
	_tmp49_ = rounded_rectangle_get_actor ((RoundedRectangle*) view);
	_tmp50_ = _tmp49_;
	_tmp51_ = trans;
	clutter_actor_add_transition (_tmp50_, "show", (ClutterTransition*) _tmp51_);
	_g_object_unref0 (view);
	_g_object_unref0 (trans);
}


static void _game_move_tile (Game* self, GridPosition* from, GridPosition* to) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	GridPosition _tmp6_ = {0};
	GridPosition _tmp7_ = {0};
	TileView** _tmp8_ = NULL;
	gint _tmp8__length1 = 0;
	gint _tmp8__length2 = 0;
	GridPosition _tmp9_ = {0};
	guint _tmp10_ = 0U;
	GridPosition _tmp11_ = {0};
	guint _tmp12_ = 0U;
	TileView** _tmp13_ = NULL;
	gint _tmp13__length1 = 0;
	gint _tmp13__length2 = 0;
	GridPosition _tmp14_ = {0};
	guint _tmp15_ = 0U;
	GridPosition _tmp16_ = {0};
	guint _tmp17_ = 0U;
	TileView* _tmp18_ = NULL;
	TileView* _tmp19_ = NULL;
	TileView* _tmp20_ = NULL;
	TileView** _tmp21_ = NULL;
	gint _tmp21__length1 = 0;
	gint _tmp21__length2 = 0;
	GridPosition _tmp22_ = {0};
	guint _tmp23_ = 0U;
	GridPosition _tmp24_ = {0};
	guint _tmp25_ = 0U;
	TileView* _tmp26_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (from != NULL);
	g_return_if_fail (to != NULL);
	_tmp0_ = grid_position_to_string (from);
	_tmp1_ = _tmp0_;
	_tmp2_ = grid_position_to_string (to);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strconcat ("move tile from ", _tmp1_, " to ", _tmp3_, NULL);
	_tmp5_ = _tmp4_;
	g_debug ("game.vala:434: %s", _tmp5_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	_tmp6_ = *from;
	_tmp7_ = *to;
	_game_prepare_move_tile (self, &_tmp6_, &_tmp7_);
	_tmp8_ = self->priv->_foreground_nxt;
	_tmp8__length1 = self->priv->_foreground_nxt_length1;
	_tmp8__length2 = self->priv->_foreground_nxt_length2;
	_tmp9_ = *to;
	_tmp10_ = _tmp9_.row;
	_tmp11_ = *to;
	_tmp12_ = _tmp11_.col;
	_tmp13_ = self->priv->_foreground_cur;
	_tmp13__length1 = self->priv->_foreground_cur_length1;
	_tmp13__length2 = self->priv->_foreground_cur_length2;
	_tmp14_ = *from;
	_tmp15_ = _tmp14_.row;
	_tmp16_ = *from;
	_tmp17_ = _tmp16_.col;
	_tmp18_ = _tmp13_[(_tmp15_ * _tmp13__length2) + _tmp17_];
	_tmp19_ = _g_object_ref0 (_tmp18_);
	_g_object_unref0 (_tmp8_[(_tmp10_ * _tmp8__length2) + _tmp12_]);
	_tmp8_[(_tmp10_ * _tmp8__length2) + _tmp12_] = _tmp19_;
	_tmp20_ = _tmp8_[(_tmp10_ * _tmp8__length2) + _tmp12_];
	_tmp21_ = self->priv->_foreground_cur;
	_tmp21__length1 = self->priv->_foreground_cur_length1;
	_tmp21__length2 = self->priv->_foreground_cur_length2;
	_tmp22_ = *from;
	_tmp23_ = _tmp22_.row;
	_tmp24_ = *from;
	_tmp25_ = _tmp24_.col;
	_g_object_unref0 (_tmp21_[(_tmp23_ * _tmp21__length2) + _tmp25_]);
	_tmp21_[(_tmp23_ * _tmp21__length2) + _tmp25_] = NULL;
	_tmp26_ = _tmp21_[(_tmp23_ * _tmp21__length2) + _tmp25_];
}


static void _game_prepare_move_tile (Game* self, GridPosition* from, GridPosition* to) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gboolean row_move = FALSE;
	gchar* trans_name = NULL;
	ClutterPropertyTransition* trans = NULL;
	RoundedRectangle* rect_from = NULL;
	RoundedRectangle* rect_to = NULL;
	GridPosition _tmp6_ = {0};
	guint _tmp7_ = 0U;
	GridPosition _tmp8_ = {0};
	guint _tmp9_ = 0U;
	const gchar* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	gchar* _tmp12_ = NULL;
	RoundedRectangle** _tmp13_ = NULL;
	gint _tmp13__length1 = 0;
	gint _tmp13__length2 = 0;
	GridPosition _tmp14_ = {0};
	guint _tmp15_ = 0U;
	GridPosition _tmp16_ = {0};
	guint _tmp17_ = 0U;
	RoundedRectangle* _tmp18_ = NULL;
	RoundedRectangle* _tmp19_ = NULL;
	RoundedRectangle** _tmp20_ = NULL;
	gint _tmp20__length1 = 0;
	gint _tmp20__length2 = 0;
	GridPosition _tmp21_ = {0};
	guint _tmp22_ = 0U;
	GridPosition _tmp23_ = {0};
	guint _tmp24_ = 0U;
	RoundedRectangle* _tmp25_ = NULL;
	RoundedRectangle* _tmp26_ = NULL;
	const gchar* _tmp27_ = NULL;
	ClutterPropertyTransition* _tmp28_ = NULL;
	gfloat _tmp29_ = 0.0F;
	gboolean _tmp30_ = FALSE;
	ClutterPropertyTransition* _tmp41_ = NULL;
	GValue _tmp42_ = {0};
	gfloat _tmp43_ = 0.0F;
	gboolean _tmp44_ = FALSE;
	ClutterPropertyTransition* _tmp55_ = NULL;
	GValue _tmp56_ = {0};
	ClutterPropertyTransition* _tmp57_ = NULL;
	ClutterPropertyTransition* _tmp58_ = NULL;
	TileView** _tmp59_ = NULL;
	gint _tmp59__length1 = 0;
	gint _tmp59__length2 = 0;
	GridPosition _tmp60_ = {0};
	guint _tmp61_ = 0U;
	GridPosition _tmp62_ = {0};
	guint _tmp63_ = 0U;
	TileView* _tmp64_ = NULL;
	ClutterActor* _tmp65_ = NULL;
	ClutterActor* _tmp66_ = NULL;
	ClutterTransitionGroup* _tmp67_ = NULL;
	ClutterPropertyTransition* _tmp68_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (from != NULL);
	g_return_if_fail (to != NULL);
	_tmp0_ = grid_position_to_string (from);
	_tmp1_ = _tmp0_;
	_tmp2_ = grid_position_to_string (to);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strconcat ("prepare move tile from ", _tmp1_, " to ", _tmp3_, NULL);
	_tmp5_ = _tmp4_;
	g_debug ("game.vala:444: %s", _tmp5_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	_tmp6_ = *from;
	_tmp7_ = _tmp6_.col;
	_tmp8_ = *to;
	_tmp9_ = _tmp8_.col;
	row_move = _tmp7_ == _tmp9_;
	_tmp11_ = row_move;
	if (_tmp11_) {
		_tmp10_ = "y";
	} else {
		_tmp10_ = "x";
	}
	_tmp12_ = g_strdup (_tmp10_);
	_g_free0 (trans_name);
	trans_name = _tmp12_;
	_tmp13_ = self->priv->_background;
	_tmp13__length1 = self->priv->_background_length1;
	_tmp13__length2 = self->priv->_background_length2;
	_tmp14_ = *from;
	_tmp15_ = _tmp14_.row;
	_tmp16_ = *from;
	_tmp17_ = _tmp16_.col;
	_tmp18_ = _tmp13_[(_tmp15_ * _tmp13__length2) + _tmp17_];
	_tmp19_ = _g_object_ref0 (_tmp18_);
	_g_object_unref0 (rect_from);
	rect_from = _tmp19_;
	_tmp20_ = self->priv->_background;
	_tmp20__length1 = self->priv->_background_length1;
	_tmp20__length2 = self->priv->_background_length2;
	_tmp21_ = *to;
	_tmp22_ = _tmp21_.row;
	_tmp23_ = *to;
	_tmp24_ = _tmp23_.col;
	_tmp25_ = _tmp20_[(_tmp22_ * _tmp20__length2) + _tmp24_];
	_tmp26_ = _g_object_ref0 (_tmp25_);
	_g_object_unref0 (rect_to);
	rect_to = _tmp26_;
	_tmp27_ = trans_name;
	_tmp28_ = (ClutterPropertyTransition*) clutter_property_transition_new (_tmp27_);
	_g_object_unref0 (trans);
	trans = _tmp28_;
	_tmp30_ = row_move;
	if (_tmp30_) {
		RoundedRectangle* _tmp31_ = NULL;
		ClutterActor* _tmp32_ = NULL;
		ClutterActor* _tmp33_ = NULL;
		gfloat _tmp34_ = 0.0F;
		gfloat _tmp35_ = 0.0F;
		_tmp31_ = rect_from;
		_tmp32_ = rounded_rectangle_get_actor (_tmp31_);
		_tmp33_ = _tmp32_;
		_tmp34_ = clutter_actor_get_y (_tmp33_);
		_tmp35_ = _tmp34_;
		_tmp29_ = _tmp35_;
	} else {
		RoundedRectangle* _tmp36_ = NULL;
		ClutterActor* _tmp37_ = NULL;
		ClutterActor* _tmp38_ = NULL;
		gfloat _tmp39_ = 0.0F;
		gfloat _tmp40_ = 0.0F;
		_tmp36_ = rect_from;
		_tmp37_ = rounded_rectangle_get_actor (_tmp36_);
		_tmp38_ = _tmp37_;
		_tmp39_ = clutter_actor_get_x (_tmp38_);
		_tmp40_ = _tmp39_;
		_tmp29_ = _tmp40_;
	}
	_tmp41_ = trans;
	g_value_init (&_tmp42_, G_TYPE_FLOAT);
	g_value_set_float (&_tmp42_, _tmp29_);
	clutter_transition_set_from_value ((ClutterTransition*) _tmp41_, &_tmp42_);
	G_IS_VALUE (&_tmp42_) ? (g_value_unset (&_tmp42_), NULL) : NULL;
	_tmp44_ = row_move;
	if (_tmp44_) {
		RoundedRectangle* _tmp45_ = NULL;
		ClutterActor* _tmp46_ = NULL;
		ClutterActor* _tmp47_ = NULL;
		gfloat _tmp48_ = 0.0F;
		gfloat _tmp49_ = 0.0F;
		_tmp45_ = rect_to;
		_tmp46_ = rounded_rectangle_get_actor (_tmp45_);
		_tmp47_ = _tmp46_;
		_tmp48_ = clutter_actor_get_y (_tmp47_);
		_tmp49_ = _tmp48_;
		_tmp43_ = _tmp49_;
	} else {
		RoundedRectangle* _tmp50_ = NULL;
		ClutterActor* _tmp51_ = NULL;
		ClutterActor* _tmp52_ = NULL;
		gfloat _tmp53_ = 0.0F;
		gfloat _tmp54_ = 0.0F;
		_tmp50_ = rect_to;
		_tmp51_ = rounded_rectangle_get_actor (_tmp50_);
		_tmp52_ = _tmp51_;
		_tmp53_ = clutter_actor_get_x (_tmp52_);
		_tmp54_ = _tmp53_;
		_tmp43_ = _tmp54_;
	}
	_tmp55_ = trans;
	g_value_init (&_tmp56_, G_TYPE_FLOAT);
	g_value_set_float (&_tmp56_, _tmp43_);
	clutter_transition_set_to_value ((ClutterTransition*) _tmp55_, &_tmp56_);
	G_IS_VALUE (&_tmp56_) ? (g_value_unset (&_tmp56_), NULL) : NULL;
	_tmp57_ = trans;
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp57_, (guint) 100);
	_tmp58_ = trans;
	_tmp59_ = self->priv->_foreground_cur;
	_tmp59__length1 = self->priv->_foreground_cur_length1;
	_tmp59__length2 = self->priv->_foreground_cur_length2;
	_tmp60_ = *from;
	_tmp61_ = _tmp60_.row;
	_tmp62_ = *from;
	_tmp63_ = _tmp62_.col;
	_tmp64_ = _tmp59_[(_tmp61_ * _tmp59__length2) + _tmp63_];
	_tmp65_ = rounded_rectangle_get_actor ((RoundedRectangle*) _tmp64_);
	_tmp66_ = _tmp65_;
	clutter_transition_set_animatable ((ClutterTransition*) _tmp58_, (ClutterAnimatable*) _tmp66_);
	_tmp67_ = self->priv->_move_trans;
	_tmp68_ = trans;
	clutter_transition_group_add_transition (_tmp67_, (ClutterTransition*) _tmp68_);
	_g_object_unref0 (rect_to);
	_g_object_unref0 (rect_from);
	_g_object_unref0 (trans);
	_g_free0 (trans_name);
}


static void _game_dim_tile (Game* self, GridPosition* pos) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	TileView** _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	gint _tmp4__length2 = 0;
	GridPosition _tmp5_ = {0};
	guint _tmp6_ = 0U;
	GridPosition _tmp7_ = {0};
	guint _tmp8_ = 0U;
	TileView* _tmp9_ = NULL;
	guint _tmp10_ = 0U;
	guint _tmp11_ = 0U;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	ClutterActor* actor = NULL;
	ClutterPropertyTransition* trans = NULL;
	TileView** _tmp16_ = NULL;
	gint _tmp16__length1 = 0;
	gint _tmp16__length2 = 0;
	GridPosition _tmp17_ = {0};
	guint _tmp18_ = 0U;
	GridPosition _tmp19_ = {0};
	guint _tmp20_ = 0U;
	TileView* _tmp21_ = NULL;
	ClutterActor* _tmp22_ = NULL;
	ClutterActor* _tmp23_ = NULL;
	ClutterActor* _tmp24_ = NULL;
	ClutterPropertyTransition* _tmp25_ = NULL;
	guint _tmp26_ = 0U;
	guint _tmp27_ = 0U;
	GValue _tmp28_ = {0};
	GValue _tmp29_ = {0};
	ClutterTransitionGroup* _tmp30_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (pos != NULL);
	_tmp0_ = grid_position_to_string (pos);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strconcat ("diming tile at ", _tmp1_, " ", NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->_foreground_cur;
	_tmp4__length1 = self->priv->_foreground_cur_length1;
	_tmp4__length2 = self->priv->_foreground_cur_length2;
	_tmp5_ = *pos;
	_tmp6_ = _tmp5_.row;
	_tmp7_ = *pos;
	_tmp8_ = _tmp7_.col;
	_tmp9_ = _tmp4_[(_tmp6_ * _tmp4__length2) + _tmp8_];
	_tmp10_ = tile_view_get_value (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = g_strdup_printf ("%u", _tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = g_strconcat (_tmp3_, _tmp13_, NULL);
	_tmp15_ = _tmp14_;
	g_debug ("game.vala:468: %s", _tmp15_);
	_g_free0 (_tmp15_);
	_g_free0 (_tmp13_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	_tmp16_ = self->priv->_foreground_cur;
	_tmp16__length1 = self->priv->_foreground_cur_length1;
	_tmp16__length2 = self->priv->_foreground_cur_length2;
	_tmp17_ = *pos;
	_tmp18_ = _tmp17_.row;
	_tmp19_ = *pos;
	_tmp20_ = _tmp19_.col;
	_tmp21_ = _tmp16_[(_tmp18_ * _tmp16__length2) + _tmp20_];
	_tmp22_ = rounded_rectangle_get_actor ((RoundedRectangle*) _tmp21_);
	_tmp23_ = _tmp22_;
	_tmp24_ = _g_object_ref0 (_tmp23_);
	_g_object_unref0 (actor);
	actor = _tmp24_;
	_tmp25_ = (ClutterPropertyTransition*) clutter_property_transition_new ("opacity");
	_g_object_unref0 (trans);
	trans = _tmp25_;
	_tmp26_ = clutter_actor_get_opacity (actor);
	_tmp27_ = _tmp26_;
	g_value_init (&_tmp28_, G_TYPE_UINT);
	g_value_set_uint (&_tmp28_, _tmp27_);
	clutter_transition_set_from_value ((ClutterTransition*) trans, &_tmp28_);
	G_IS_VALUE (&_tmp28_) ? (g_value_unset (&_tmp28_), NULL) : NULL;
	g_value_init (&_tmp29_, G_TYPE_INT);
	g_value_set_int (&_tmp29_, 0);
	clutter_transition_set_to_value ((ClutterTransition*) trans, &_tmp29_);
	G_IS_VALUE (&_tmp29_) ? (g_value_unset (&_tmp29_), NULL) : NULL;
	clutter_timeline_set_duration ((ClutterTimeline*) trans, (guint) 100);
	clutter_transition_set_animatable ((ClutterTransition*) trans, (ClutterAnimatable*) actor);
	_tmp30_ = self->priv->_show_hide_trans;
	clutter_transition_group_add_transition (_tmp30_, (ClutterTransition*) trans);
	_g_object_unref0 (trans);
	_g_object_unref0 (actor);
}


static void _game_clear_background (Game* self) {
	gint rows = 0;
	Grid* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint cols = 0;
	Grid* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_grid;
	_tmp1_ = grid_get_rows (_tmp0_);
	_tmp2_ = _tmp1_;
	rows = _tmp2_;
	_tmp3_ = self->priv->_grid;
	_tmp4_ = grid_get_cols (_tmp3_);
	_tmp5_ = _tmp4_;
	cols = _tmp5_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp6_ = FALSE;
			_tmp6_ = TRUE;
			while (TRUE) {
				gint _tmp8_ = 0;
				gint _tmp9_ = 0;
				if (!_tmp6_) {
					gint _tmp7_ = 0;
					_tmp7_ = i;
					i = _tmp7_ + 1;
				}
				_tmp6_ = FALSE;
				_tmp8_ = i;
				_tmp9_ = rows;
				if (!(_tmp8_ < _tmp9_)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp10_ = FALSE;
						_tmp10_ = TRUE;
						while (TRUE) {
							gint _tmp12_ = 0;
							gint _tmp13_ = 0;
							RoundedRectangle* rect = NULL;
							RoundedRectangle** _tmp14_ = NULL;
							gint _tmp14__length1 = 0;
							gint _tmp14__length2 = 0;
							gint _tmp15_ = 0;
							gint _tmp16_ = 0;
							RoundedRectangle* _tmp17_ = NULL;
							RoundedRectangle* _tmp18_ = NULL;
							RoundedRectangle* _tmp19_ = NULL;
							ClutterActor* _tmp20_ = NULL;
							ClutterActor* _tmp21_ = NULL;
							ClutterActor* _tmp22_ = NULL;
							RoundedRectangle* _tmp23_ = NULL;
							ClutterActor* _tmp24_ = NULL;
							ClutterActor* _tmp25_ = NULL;
							if (!_tmp10_) {
								gint _tmp11_ = 0;
								_tmp11_ = j;
								j = _tmp11_ + 1;
							}
							_tmp10_ = FALSE;
							_tmp12_ = j;
							_tmp13_ = cols;
							if (!(_tmp12_ < _tmp13_)) {
								break;
							}
							_tmp14_ = self->priv->_background;
							_tmp14__length1 = self->priv->_background_length1;
							_tmp14__length2 = self->priv->_background_length2;
							_tmp15_ = i;
							_tmp16_ = j;
							_tmp17_ = _tmp14_[(_tmp15_ * _tmp14__length2) + _tmp16_];
							_tmp18_ = _g_object_ref0 (_tmp17_);
							rect = _tmp18_;
							_tmp19_ = rect;
							_tmp20_ = rounded_rectangle_get_actor (_tmp19_);
							_tmp21_ = _tmp20_;
							clutter_actor_hide (_tmp21_);
							_tmp22_ = self->priv->_view;
							_tmp23_ = rect;
							_tmp24_ = rounded_rectangle_get_actor (_tmp23_);
							_tmp25_ = _tmp24_;
							clutter_actor_remove_child (_tmp22_, _tmp25_);
							_g_object_unref0 (rect);
						}
					}
				}
			}
		}
	}
}


static void _game_clear_foreground (Game* self) {
	gint rows = 0;
	Grid* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint cols = 0;
	Grid* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_grid;
	_tmp1_ = grid_get_rows (_tmp0_);
	_tmp2_ = _tmp1_;
	rows = _tmp2_;
	_tmp3_ = self->priv->_grid;
	_tmp4_ = grid_get_cols (_tmp3_);
	_tmp5_ = _tmp4_;
	cols = _tmp5_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp6_ = FALSE;
			_tmp6_ = TRUE;
			while (TRUE) {
				gint _tmp8_ = 0;
				gint _tmp9_ = 0;
				if (!_tmp6_) {
					gint _tmp7_ = 0;
					_tmp7_ = i;
					i = _tmp7_ + 1;
				}
				_tmp6_ = FALSE;
				_tmp8_ = i;
				_tmp9_ = rows;
				if (!(_tmp8_ < _tmp9_)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp10_ = FALSE;
						_tmp10_ = TRUE;
						while (TRUE) {
							gint _tmp12_ = 0;
							gint _tmp13_ = 0;
							TileView** _tmp14_ = NULL;
							gint _tmp14__length1 = 0;
							gint _tmp14__length2 = 0;
							gint _tmp15_ = 0;
							gint _tmp16_ = 0;
							TileView* _tmp17_ = NULL;
							if (!_tmp10_) {
								gint _tmp11_ = 0;
								_tmp11_ = j;
								j = _tmp11_ + 1;
							}
							_tmp10_ = FALSE;
							_tmp12_ = j;
							_tmp13_ = cols;
							if (!(_tmp12_ < _tmp13_)) {
								break;
							}
							_tmp14_ = self->priv->_foreground_cur;
							_tmp14__length1 = self->priv->_foreground_cur_length1;
							_tmp14__length2 = self->priv->_foreground_cur_length2;
							_tmp15_ = i;
							_tmp16_ = j;
							_tmp17_ = _tmp14_[(_tmp15_ * _tmp14__length2) + _tmp16_];
							if (_tmp17_ != NULL) {
								TileView* tile = NULL;
								TileView** _tmp18_ = NULL;
								gint _tmp18__length1 = 0;
								gint _tmp18__length2 = 0;
								gint _tmp19_ = 0;
								gint _tmp20_ = 0;
								TileView* _tmp21_ = NULL;
								TileView* _tmp22_ = NULL;
								TileView* _tmp23_ = NULL;
								ClutterActor* _tmp24_ = NULL;
								ClutterActor* _tmp25_ = NULL;
								ClutterActor* _tmp26_ = NULL;
								TileView* _tmp27_ = NULL;
								ClutterActor* _tmp28_ = NULL;
								ClutterActor* _tmp29_ = NULL;
								TileView** _tmp30_ = NULL;
								gint _tmp30__length1 = 0;
								gint _tmp30__length2 = 0;
								gint _tmp31_ = 0;
								gint _tmp32_ = 0;
								TileView* _tmp33_ = NULL;
								_tmp18_ = self->priv->_foreground_cur;
								_tmp18__length1 = self->priv->_foreground_cur_length1;
								_tmp18__length2 = self->priv->_foreground_cur_length2;
								_tmp19_ = i;
								_tmp20_ = j;
								_tmp21_ = _tmp18_[(_tmp19_ * _tmp18__length2) + _tmp20_];
								_tmp22_ = _g_object_ref0 (_tmp21_);
								tile = _tmp22_;
								_tmp23_ = tile;
								_tmp24_ = rounded_rectangle_get_actor ((RoundedRectangle*) _tmp23_);
								_tmp25_ = _tmp24_;
								clutter_actor_hide (_tmp25_);
								_tmp26_ = self->priv->_view;
								_tmp27_ = tile;
								_tmp28_ = rounded_rectangle_get_actor ((RoundedRectangle*) _tmp27_);
								_tmp29_ = _tmp28_;
								clutter_actor_remove_child (_tmp26_, _tmp29_);
								_tmp30_ = self->priv->_foreground_cur;
								_tmp30__length1 = self->priv->_foreground_cur_length1;
								_tmp30__length2 = self->priv->_foreground_cur_length2;
								_tmp31_ = i;
								_tmp32_ = j;
								_g_object_unref0 (_tmp30_[(_tmp31_ * _tmp30__length2) + _tmp32_]);
								_tmp30_[(_tmp31_ * _tmp30__length2) + _tmp32_] = NULL;
								_tmp33_ = _tmp30_[(_tmp31_ * _tmp30__length2) + _tmp32_];
								_g_object_unref0 (tile);
							}
						}
					}
				}
			}
		}
	}
}


static void _game_restore_foreground (Game* self) {
	guint val = 0U;
	GridPosition pos = {0};
	Tile tile = {0};
	gint rows = 0;
	Grid* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint cols = 0;
	Grid* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	GeeLinkedList* _tmp29_ = NULL;
	gint _tmp30_ = 0;
	gint _tmp31_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_grid;
	_tmp1_ = grid_get_rows (_tmp0_);
	_tmp2_ = _tmp1_;
	rows = _tmp2_;
	_tmp3_ = self->priv->_grid;
	_tmp4_ = grid_get_cols (_tmp3_);
	_tmp5_ = _tmp4_;
	cols = _tmp5_;
	_game_create_show_hide_transition (self);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp6_ = FALSE;
			_tmp6_ = TRUE;
			while (TRUE) {
				gint _tmp8_ = 0;
				gint _tmp9_ = 0;
				if (!_tmp6_) {
					gint _tmp7_ = 0;
					_tmp7_ = i;
					i = _tmp7_ + 1;
				}
				_tmp6_ = FALSE;
				_tmp8_ = i;
				_tmp9_ = rows;
				if (!(_tmp8_ < _tmp9_)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp10_ = FALSE;
						_tmp10_ = TRUE;
						while (TRUE) {
							gint _tmp12_ = 0;
							gint _tmp13_ = 0;
							Grid* _tmp14_ = NULL;
							gint _tmp15_ = 0;
							gint _tmp16_ = 0;
							guint _tmp17_ = 0U;
							guint _tmp18_ = 0U;
							if (!_tmp10_) {
								gint _tmp11_ = 0;
								_tmp11_ = j;
								j = _tmp11_ + 1;
							}
							_tmp10_ = FALSE;
							_tmp12_ = j;
							_tmp13_ = cols;
							if (!(_tmp12_ < _tmp13_)) {
								break;
							}
							_tmp14_ = self->priv->_grid;
							_tmp15_ = i;
							_tmp16_ = j;
							_tmp17_ = grid_get (_tmp14_, _tmp15_, _tmp16_);
							val = _tmp17_;
							_tmp18_ = val;
							if (_tmp18_ != ((guint) 0)) {
								gint _tmp19_ = 0;
								gint _tmp20_ = 0;
								GridPosition _tmp21_ = {0};
								GridPosition _tmp22_ = {0};
								guint _tmp23_ = 0U;
								Tile _tmp24_ = {0};
								Tile _tmp25_ = {0};
								GeeLinkedList* _tmp26_ = NULL;
								Tile _tmp27_ = {0};
								GridPosition _tmp28_ = {0};
								_tmp19_ = i;
								_tmp20_ = j;
								_tmp21_.row = (guint) _tmp19_;
								_tmp21_.col = (guint) _tmp20_;
								pos = _tmp21_;
								_tmp22_ = pos;
								_tmp23_ = val;
								_tmp24_.pos = _tmp22_;
								_tmp24_.val = _tmp23_;
								tile = _tmp24_;
								_tmp25_ = tile;
								_game_create_tile (self, &_tmp25_);
								_tmp26_ = self->priv->_to_show;
								_tmp27_ = tile;
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, &_tmp27_);
								_tmp28_ = pos;
								_game_show_tile (self, &_tmp28_);
							}
						}
					}
				}
			}
		}
	}
	_tmp29_ = self->priv->_to_show;
	_tmp30_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp29_);
	_tmp31_ = _tmp30_;
	if (_tmp31_ > 0) {
		ClutterTransitionGroup* _tmp32_ = NULL;
		self->priv->_state = GAME_GAME_STATE_RESTORING_TILES;
		_tmp32_ = self->priv->_show_hide_trans;
		clutter_timeline_start ((ClutterTimeline*) _tmp32_);
	}
}


static gchar* bool_to_string (gboolean self) {
	gchar* result = NULL;
	if (self) {
		gchar* _tmp0_ = NULL;
		_tmp0_ = g_strdup ("true");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_ = NULL;
		_tmp1_ = g_strdup ("false");
		result = _tmp1_;
		return result;
	}
}


static void _game_on_move_trans_stopped (Game* self, gboolean is_finished) {
	gboolean _tmp0_ = FALSE;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	Grid* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	guint delta_score = 0U;
	ClutterTransitionGroup* _tmp8_ = NULL;
	guint _tmp40_ = 0U;
	guint _tmp41_ = 0U;
	ClutterTransitionGroup* _tmp42_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = is_finished;
	_tmp1_ = bool_to_string (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat ("move animation stopped; finished ", _tmp2_, NULL);
	_tmp4_ = _tmp3_;
	g_debug ("game.vala:546: %s", _tmp4_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	_tmp5_ = self->priv->_grid;
	_tmp6_ = grid_to_string (_tmp5_);
	_tmp7_ = _tmp6_;
	g_debug ("game.vala:547: %s", _tmp7_);
	_g_free0 (_tmp7_);
	_tmp8_ = self->priv->_move_trans;
	clutter_transition_group_remove_all (_tmp8_);
	_game_create_show_hide_transition (self);
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp9_ = NULL;
		GeeLinkedList* _tmp10_ = NULL;
		gint _e_size = 0;
		GeeLinkedList* _tmp11_ = NULL;
		gint _tmp12_ = 0;
		gint _tmp13_ = 0;
		gint _e_index = 0;
		_tmp9_ = self->priv->_to_hide;
		_tmp10_ = _g_object_ref0 (_tmp9_);
		_e_list = _tmp10_;
		_tmp11_ = _e_list;
		_tmp12_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp11_);
		_tmp13_ = _tmp12_;
		_e_size = _tmp13_;
		_e_index = -1;
		while (TRUE) {
			gint _tmp14_ = 0;
			gint _tmp15_ = 0;
			gint _tmp16_ = 0;
			TileMovement* e = NULL;
			GeeLinkedList* _tmp17_ = NULL;
			gint _tmp18_ = 0;
			gpointer _tmp19_ = NULL;
			TileMovement* _tmp20_ = NULL;
			GridPosition _tmp21_ = {0};
			_tmp14_ = _e_index;
			_e_index = _tmp14_ + 1;
			_tmp15_ = _e_index;
			_tmp16_ = _e_size;
			if (!(_tmp15_ < _tmp16_)) {
				break;
			}
			_tmp17_ = _e_list;
			_tmp18_ = _e_index;
			_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, _tmp18_);
			e = (TileMovement*) _tmp19_;
			_tmp20_ = e;
			_tmp21_ = (*_tmp20_).from;
			_game_dim_tile (self, &_tmp21_);
			_tile_movement_free0 (e);
		}
		_g_object_unref0 (_e_list);
	}
	delta_score = (guint) 0;
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp22_ = NULL;
		GeeLinkedList* _tmp23_ = NULL;
		gint _e_size = 0;
		GeeLinkedList* _tmp24_ = NULL;
		gint _tmp25_ = 0;
		gint _tmp26_ = 0;
		gint _e_index = 0;
		_tmp22_ = self->priv->_to_show;
		_tmp23_ = _g_object_ref0 (_tmp22_);
		_e_list = _tmp23_;
		_tmp24_ = _e_list;
		_tmp25_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp24_);
		_tmp26_ = _tmp25_;
		_e_size = _tmp26_;
		_e_index = -1;
		while (TRUE) {
			gint _tmp27_ = 0;
			gint _tmp28_ = 0;
			gint _tmp29_ = 0;
			Tile* e = NULL;
			GeeLinkedList* _tmp30_ = NULL;
			gint _tmp31_ = 0;
			gpointer _tmp32_ = NULL;
			Tile* _tmp33_ = NULL;
			Tile _tmp34_ = {0};
			Tile* _tmp35_ = NULL;
			GridPosition _tmp36_ = {0};
			guint _tmp37_ = 0U;
			Tile* _tmp38_ = NULL;
			guint _tmp39_ = 0U;
			_tmp27_ = _e_index;
			_e_index = _tmp27_ + 1;
			_tmp28_ = _e_index;
			_tmp29_ = _e_size;
			if (!(_tmp28_ < _tmp29_)) {
				break;
			}
			_tmp30_ = _e_list;
			_tmp31_ = _e_index;
			_tmp32_ = gee_abstract_list_get ((GeeAbstractList*) _tmp30_, _tmp31_);
			e = (Tile*) _tmp32_;
			_tmp33_ = e;
			_tmp34_ = *_tmp33_;
			_game_create_tile (self, &_tmp34_);
			_tmp35_ = e;
			_tmp36_ = (*_tmp35_).pos;
			_game_show_tile (self, &_tmp36_);
			_tmp37_ = delta_score;
			_tmp38_ = e;
			_tmp39_ = (*_tmp38_).val;
			delta_score = _tmp37_ + _tmp39_;
			_tile_free0 (e);
		}
		_g_object_unref0 (_e_list);
	}
	_tmp40_ = self->priv->_score;
	_tmp41_ = delta_score;
	game_set_score (self, _tmp40_ + _tmp41_);
	_game_create_random_tile (self);
	_tmp42_ = self->priv->_show_hide_trans;
	clutter_timeline_start ((ClutterTimeline*) _tmp42_);
}


static void _game_on_show_hide_trans_stopped (Game* self, gboolean is_finished) {
	gboolean _tmp0_ = FALSE;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	Grid* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	ClutterTransitionGroup* _tmp8_ = NULL;
	GameGameState _tmp58_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = is_finished;
	_tmp1_ = bool_to_string (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat ("show/hide animation stopped; finished ", _tmp2_, NULL);
	_tmp4_ = _tmp3_;
	g_debug ("game.vala:574: %s", _tmp4_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	_tmp5_ = self->priv->_grid;
	_tmp6_ = grid_to_string (_tmp5_);
	_tmp7_ = _tmp6_;
	g_debug ("game.vala:575: %s", _tmp7_);
	_g_free0 (_tmp7_);
	_tmp8_ = self->priv->_show_hide_trans;
	clutter_transition_group_remove_all (_tmp8_);
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp9_ = NULL;
		GeeLinkedList* _tmp10_ = NULL;
		gint _e_size = 0;
		GeeLinkedList* _tmp11_ = NULL;
		gint _tmp12_ = 0;
		gint _tmp13_ = 0;
		gint _e_index = 0;
		_tmp9_ = self->priv->_to_hide;
		_tmp10_ = _g_object_ref0 (_tmp9_);
		_e_list = _tmp10_;
		_tmp11_ = _e_list;
		_tmp12_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp11_);
		_tmp13_ = _tmp12_;
		_e_size = _tmp13_;
		_e_index = -1;
		while (TRUE) {
			gint _tmp14_ = 0;
			gint _tmp15_ = 0;
			gint _tmp16_ = 0;
			TileMovement* e = NULL;
			GeeLinkedList* _tmp17_ = NULL;
			gint _tmp18_ = 0;
			gpointer _tmp19_ = NULL;
			TileView* view = NULL;
			TileView** _tmp20_ = NULL;
			gint _tmp20__length1 = 0;
			gint _tmp20__length2 = 0;
			TileMovement* _tmp21_ = NULL;
			GridPosition _tmp22_ = {0};
			guint _tmp23_ = 0U;
			TileMovement* _tmp24_ = NULL;
			GridPosition _tmp25_ = {0};
			guint _tmp26_ = 0U;
			TileView* _tmp27_ = NULL;
			TileView* _tmp28_ = NULL;
			TileView* _tmp29_ = NULL;
			ClutterActor* _tmp30_ = NULL;
			ClutterActor* _tmp31_ = NULL;
			TileView** _tmp32_ = NULL;
			gint _tmp32__length1 = 0;
			gint _tmp32__length2 = 0;
			TileMovement* _tmp33_ = NULL;
			GridPosition _tmp34_ = {0};
			guint _tmp35_ = 0U;
			TileMovement* _tmp36_ = NULL;
			GridPosition _tmp37_ = {0};
			guint _tmp38_ = 0U;
			TileView* _tmp39_ = NULL;
			guint _tmp40_ = 0U;
			guint _tmp41_ = 0U;
			gchar* _tmp42_ = NULL;
			gchar* _tmp43_ = NULL;
			gchar* _tmp44_ = NULL;
			gchar* _tmp45_ = NULL;
			ClutterActor* _tmp46_ = NULL;
			TileView* _tmp47_ = NULL;
			ClutterActor* _tmp48_ = NULL;
			ClutterActor* _tmp49_ = NULL;
			TileView** _tmp50_ = NULL;
			gint _tmp50__length1 = 0;
			gint _tmp50__length2 = 0;
			TileMovement* _tmp51_ = NULL;
			GridPosition _tmp52_ = {0};
			guint _tmp53_ = 0U;
			TileMovement* _tmp54_ = NULL;
			GridPosition _tmp55_ = {0};
			guint _tmp56_ = 0U;
			TileView* _tmp57_ = NULL;
			_tmp14_ = _e_index;
			_e_index = _tmp14_ + 1;
			_tmp15_ = _e_index;
			_tmp16_ = _e_size;
			if (!(_tmp15_ < _tmp16_)) {
				break;
			}
			_tmp17_ = _e_list;
			_tmp18_ = _e_index;
			_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, _tmp18_);
			e = (TileMovement*) _tmp19_;
			_tmp20_ = self->priv->_foreground_cur;
			_tmp20__length1 = self->priv->_foreground_cur_length1;
			_tmp20__length2 = self->priv->_foreground_cur_length2;
			_tmp21_ = e;
			_tmp22_ = (*_tmp21_).from;
			_tmp23_ = _tmp22_.row;
			_tmp24_ = e;
			_tmp25_ = (*_tmp24_).from;
			_tmp26_ = _tmp25_.col;
			_tmp27_ = _tmp20_[(_tmp23_ * _tmp20__length2) + _tmp26_];
			_tmp28_ = _g_object_ref0 (_tmp27_);
			view = _tmp28_;
			_tmp29_ = view;
			_tmp30_ = rounded_rectangle_get_actor ((RoundedRectangle*) _tmp29_);
			_tmp31_ = _tmp30_;
			clutter_actor_hide (_tmp31_);
			_tmp32_ = self->priv->_foreground_cur;
			_tmp32__length1 = self->priv->_foreground_cur_length1;
			_tmp32__length2 = self->priv->_foreground_cur_length2;
			_tmp33_ = e;
			_tmp34_ = (*_tmp33_).from;
			_tmp35_ = _tmp34_.row;
			_tmp36_ = e;
			_tmp37_ = (*_tmp36_).from;
			_tmp38_ = _tmp37_.col;
			_tmp39_ = _tmp32_[(_tmp35_ * _tmp32__length2) + _tmp38_];
			_tmp40_ = tile_view_get_value (_tmp39_);
			_tmp41_ = _tmp40_;
			_tmp42_ = g_strdup_printf ("%u", _tmp41_);
			_tmp43_ = _tmp42_;
			_tmp44_ = g_strconcat ("remove child ", _tmp43_, NULL);
			_tmp45_ = _tmp44_;
			g_debug ("game.vala:582: %s", _tmp45_);
			_g_free0 (_tmp45_);
			_g_free0 (_tmp43_);
			_tmp46_ = self->priv->_view;
			_tmp47_ = view;
			_tmp48_ = rounded_rectangle_get_actor ((RoundedRectangle*) _tmp47_);
			_tmp49_ = _tmp48_;
			clutter_actor_remove_child (_tmp46_, _tmp49_);
			_tmp50_ = self->priv->_foreground_cur;
			_tmp50__length1 = self->priv->_foreground_cur_length1;
			_tmp50__length2 = self->priv->_foreground_cur_length2;
			_tmp51_ = e;
			_tmp52_ = (*_tmp51_).from;
			_tmp53_ = _tmp52_.row;
			_tmp54_ = e;
			_tmp55_ = (*_tmp54_).from;
			_tmp56_ = _tmp55_.col;
			_g_object_unref0 (_tmp50_[(_tmp53_ * _tmp50__length2) + _tmp56_]);
			_tmp50_[(_tmp53_ * _tmp50__length2) + _tmp56_] = NULL;
			_tmp57_ = _tmp50_[(_tmp53_ * _tmp50__length2) + _tmp56_];
			_g_object_unref0 (view);
			_tile_movement_free0 (e);
		}
		_g_object_unref0 (_e_list);
	}
	_game_finish_move (self);
	_tmp58_ = self->priv->_state;
	if (_tmp58_ == GAME_GAME_STATE_SHOWING_FIRST_TILE) {
		self->priv->_state = GAME_GAME_STATE_SHOWING_SECOND_TILE;
		g_debug ("game.vala:592: state show second tile");
		_game_create_random_tile (self);
	} else {
		GameGameState _tmp59_ = 0;
		_tmp59_ = self->priv->_state;
		if (_tmp59_ == GAME_GAME_STATE_SHOWING_SECOND_TILE) {
			self->priv->_state = GAME_GAME_STATE_IDLE;
			g_debug ("game.vala:596: state idle");
		} else {
			GameGameState _tmp60_ = 0;
			_tmp60_ = self->priv->_state;
			if (_tmp60_ != GAME_GAME_STATE_IDLE) {
				self->priv->_state = GAME_GAME_STATE_IDLE;
				g_debug ("game.vala:599: state idle");
			}
		}
	}
}


static void __game_on_show_hide_trans_stopped_clutter_timeline_stopped (ClutterTimeline* _sender, gboolean is_finished, gpointer self) {
	_game_on_show_hide_trans_stopped ((Game*) self, is_finished);
}


static void _game_create_show_hide_transition (Game* self) {
	ClutterTransitionGroup* _tmp0_ = NULL;
	ClutterTransitionGroup* _tmp1_ = NULL;
	ClutterTransitionGroup* _tmp2_ = NULL;
	ClutterTransitionGroup* _tmp3_ = NULL;
	ClutterTransitionGroup* _tmp4_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = (ClutterTransitionGroup*) clutter_transition_group_new ();
	_g_object_unref0 (self->priv->_show_hide_trans);
	self->priv->_show_hide_trans = _tmp0_;
	_tmp1_ = self->priv->_show_hide_trans;
	g_signal_connect_object ((ClutterTimeline*) _tmp1_, "stopped", (GCallback) __game_on_show_hide_trans_stopped_clutter_timeline_stopped, self, 0);
	_tmp2_ = self->priv->_show_hide_trans;
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp2_, (guint) 100);
	_tmp3_ = self->priv->_show_hide_trans;
	clutter_timeline_set_auto_reverse ((ClutterTimeline*) _tmp3_, TRUE);
	_tmp4_ = self->priv->_show_hide_trans;
	clutter_timeline_set_repeat_count ((ClutterTimeline*) _tmp4_, 1);
}


static void _game_finish_move (Game* self) {
	GeeLinkedList* _tmp72_ = NULL;
	GeeLinkedList* _tmp73_ = NULL;
	GeeLinkedList* _tmp74_ = NULL;
	Grid* _tmp75_ = NULL;
	gboolean _tmp76_ = FALSE;
	g_return_if_fail (self != NULL);
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp0_ = NULL;
		GeeLinkedList* _tmp1_ = NULL;
		gint _e_size = 0;
		GeeLinkedList* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gint _e_index = 0;
		_tmp0_ = self->priv->_to_move;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_e_list = _tmp1_;
		_tmp2_ = _e_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_e_size = _tmp4_;
		_e_index = -1;
		while (TRUE) {
			gint _tmp5_ = 0;
			gint _tmp6_ = 0;
			gint _tmp7_ = 0;
			TileMovement* e = NULL;
			GeeLinkedList* _tmp8_ = NULL;
			gint _tmp9_ = 0;
			gpointer _tmp10_ = NULL;
			TileView** _tmp11_ = NULL;
			gint _tmp11__length1 = 0;
			gint _tmp11__length2 = 0;
			TileMovement* _tmp12_ = NULL;
			GridPosition _tmp13_ = {0};
			guint _tmp14_ = 0U;
			TileMovement* _tmp15_ = NULL;
			GridPosition _tmp16_ = {0};
			guint _tmp17_ = 0U;
			TileView** _tmp18_ = NULL;
			gint _tmp18__length1 = 0;
			gint _tmp18__length2 = 0;
			TileMovement* _tmp19_ = NULL;
			GridPosition _tmp20_ = {0};
			guint _tmp21_ = 0U;
			TileMovement* _tmp22_ = NULL;
			GridPosition _tmp23_ = {0};
			guint _tmp24_ = 0U;
			TileView* _tmp25_ = NULL;
			TileView* _tmp26_ = NULL;
			TileView* _tmp27_ = NULL;
			TileView** _tmp28_ = NULL;
			gint _tmp28__length1 = 0;
			gint _tmp28__length2 = 0;
			TileMovement* _tmp29_ = NULL;
			GridPosition _tmp30_ = {0};
			guint _tmp31_ = 0U;
			TileMovement* _tmp32_ = NULL;
			GridPosition _tmp33_ = {0};
			guint _tmp34_ = 0U;
			TileView* _tmp35_ = NULL;
			_tmp5_ = _e_index;
			_e_index = _tmp5_ + 1;
			_tmp6_ = _e_index;
			_tmp7_ = _e_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _e_list;
			_tmp9_ = _e_index;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
			e = (TileMovement*) _tmp10_;
			_tmp11_ = self->priv->_foreground_cur;
			_tmp11__length1 = self->priv->_foreground_cur_length1;
			_tmp11__length2 = self->priv->_foreground_cur_length2;
			_tmp12_ = e;
			_tmp13_ = (*_tmp12_).to;
			_tmp14_ = _tmp13_.row;
			_tmp15_ = e;
			_tmp16_ = (*_tmp15_).to;
			_tmp17_ = _tmp16_.col;
			_tmp18_ = self->priv->_foreground_nxt;
			_tmp18__length1 = self->priv->_foreground_nxt_length1;
			_tmp18__length2 = self->priv->_foreground_nxt_length2;
			_tmp19_ = e;
			_tmp20_ = (*_tmp19_).to;
			_tmp21_ = _tmp20_.row;
			_tmp22_ = e;
			_tmp23_ = (*_tmp22_).to;
			_tmp24_ = _tmp23_.col;
			_tmp25_ = _tmp18_[(_tmp21_ * _tmp18__length2) + _tmp24_];
			_tmp26_ = _g_object_ref0 (_tmp25_);
			_g_object_unref0 (_tmp11_[(_tmp14_ * _tmp11__length2) + _tmp17_]);
			_tmp11_[(_tmp14_ * _tmp11__length2) + _tmp17_] = _tmp26_;
			_tmp27_ = _tmp11_[(_tmp14_ * _tmp11__length2) + _tmp17_];
			_tmp28_ = self->priv->_foreground_nxt;
			_tmp28__length1 = self->priv->_foreground_nxt_length1;
			_tmp28__length2 = self->priv->_foreground_nxt_length2;
			_tmp29_ = e;
			_tmp30_ = (*_tmp29_).to;
			_tmp31_ = _tmp30_.row;
			_tmp32_ = e;
			_tmp33_ = (*_tmp32_).to;
			_tmp34_ = _tmp33_.col;
			_g_object_unref0 (_tmp28_[(_tmp31_ * _tmp28__length2) + _tmp34_]);
			_tmp28_[(_tmp31_ * _tmp28__length2) + _tmp34_] = NULL;
			_tmp35_ = _tmp28_[(_tmp31_ * _tmp28__length2) + _tmp34_];
			_tile_movement_free0 (e);
		}
		_g_object_unref0 (_e_list);
	}
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp36_ = NULL;
		GeeLinkedList* _tmp37_ = NULL;
		gint _e_size = 0;
		GeeLinkedList* _tmp38_ = NULL;
		gint _tmp39_ = 0;
		gint _tmp40_ = 0;
		gint _e_index = 0;
		_tmp36_ = self->priv->_to_show;
		_tmp37_ = _g_object_ref0 (_tmp36_);
		_e_list = _tmp37_;
		_tmp38_ = _e_list;
		_tmp39_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp38_);
		_tmp40_ = _tmp39_;
		_e_size = _tmp40_;
		_e_index = -1;
		while (TRUE) {
			gint _tmp41_ = 0;
			gint _tmp42_ = 0;
			gint _tmp43_ = 0;
			Tile* e = NULL;
			GeeLinkedList* _tmp44_ = NULL;
			gint _tmp45_ = 0;
			gpointer _tmp46_ = NULL;
			TileView** _tmp47_ = NULL;
			gint _tmp47__length1 = 0;
			gint _tmp47__length2 = 0;
			Tile* _tmp48_ = NULL;
			GridPosition _tmp49_ = {0};
			guint _tmp50_ = 0U;
			Tile* _tmp51_ = NULL;
			GridPosition _tmp52_ = {0};
			guint _tmp53_ = 0U;
			TileView** _tmp54_ = NULL;
			gint _tmp54__length1 = 0;
			gint _tmp54__length2 = 0;
			Tile* _tmp55_ = NULL;
			GridPosition _tmp56_ = {0};
			guint _tmp57_ = 0U;
			Tile* _tmp58_ = NULL;
			GridPosition _tmp59_ = {0};
			guint _tmp60_ = 0U;
			TileView* _tmp61_ = NULL;
			TileView* _tmp62_ = NULL;
			TileView* _tmp63_ = NULL;
			TileView** _tmp64_ = NULL;
			gint _tmp64__length1 = 0;
			gint _tmp64__length2 = 0;
			Tile* _tmp65_ = NULL;
			GridPosition _tmp66_ = {0};
			guint _tmp67_ = 0U;
			Tile* _tmp68_ = NULL;
			GridPosition _tmp69_ = {0};
			guint _tmp70_ = 0U;
			TileView* _tmp71_ = NULL;
			_tmp41_ = _e_index;
			_e_index = _tmp41_ + 1;
			_tmp42_ = _e_index;
			_tmp43_ = _e_size;
			if (!(_tmp42_ < _tmp43_)) {
				break;
			}
			_tmp44_ = _e_list;
			_tmp45_ = _e_index;
			_tmp46_ = gee_abstract_list_get ((GeeAbstractList*) _tmp44_, _tmp45_);
			e = (Tile*) _tmp46_;
			_tmp47_ = self->priv->_foreground_cur;
			_tmp47__length1 = self->priv->_foreground_cur_length1;
			_tmp47__length2 = self->priv->_foreground_cur_length2;
			_tmp48_ = e;
			_tmp49_ = (*_tmp48_).pos;
			_tmp50_ = _tmp49_.row;
			_tmp51_ = e;
			_tmp52_ = (*_tmp51_).pos;
			_tmp53_ = _tmp52_.col;
			_tmp54_ = self->priv->_foreground_nxt;
			_tmp54__length1 = self->priv->_foreground_nxt_length1;
			_tmp54__length2 = self->priv->_foreground_nxt_length2;
			_tmp55_ = e;
			_tmp56_ = (*_tmp55_).pos;
			_tmp57_ = _tmp56_.row;
			_tmp58_ = e;
			_tmp59_ = (*_tmp58_).pos;
			_tmp60_ = _tmp59_.col;
			_tmp61_ = _tmp54_[(_tmp57_ * _tmp54__length2) + _tmp60_];
			_tmp62_ = _g_object_ref0 (_tmp61_);
			_g_object_unref0 (_tmp47_[(_tmp50_ * _tmp47__length2) + _tmp53_]);
			_tmp47_[(_tmp50_ * _tmp47__length2) + _tmp53_] = _tmp62_;
			_tmp63_ = _tmp47_[(_tmp50_ * _tmp47__length2) + _tmp53_];
			_tmp64_ = self->priv->_foreground_nxt;
			_tmp64__length1 = self->priv->_foreground_nxt_length1;
			_tmp64__length2 = self->priv->_foreground_nxt_length2;
			_tmp65_ = e;
			_tmp66_ = (*_tmp65_).pos;
			_tmp67_ = _tmp66_.row;
			_tmp68_ = e;
			_tmp69_ = (*_tmp68_).pos;
			_tmp70_ = _tmp69_.col;
			_g_object_unref0 (_tmp64_[(_tmp67_ * _tmp64__length2) + _tmp70_]);
			_tmp64_[(_tmp67_ * _tmp64__length2) + _tmp70_] = NULL;
			_tmp71_ = _tmp64_[(_tmp67_ * _tmp64__length2) + _tmp70_];
			_tile_free0 (e);
		}
		_g_object_unref0 (_e_list);
	}
	_tmp72_ = self->priv->_to_hide;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp72_);
	_tmp73_ = self->priv->_to_move;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp73_);
	_tmp74_ = self->priv->_to_show;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp74_);
	_tmp75_ = self->priv->_grid;
	_tmp76_ = grid_is_finished (_tmp75_);
	if (_tmp76_) {
		g_signal_emit_by_name (self, "finished");
	}
}


ClutterActor* game_get_view (Game* self) {
	ClutterActor* result;
	ClutterActor* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_view;
	result = _tmp0_;
	return result;
}


static void __game_on_allocation_changed_clutter_actor_allocation_changed (ClutterActor* _sender, ClutterActorBox* box, ClutterAllocationFlags flags, gpointer self) {
	_game_on_allocation_changed ((Game*) self, box, flags);
}


void game_set_view (Game* self, ClutterActor* value) {
	ClutterActor* _tmp0_ = NULL;
	ClutterActor* _tmp1_ = NULL;
	ClutterActor* _tmp2_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_view);
	self->priv->_view = _tmp1_;
	_tmp2_ = self->priv->_view;
	g_signal_connect_object (_tmp2_, "allocation-changed", (GCallback) __game_on_allocation_changed_clutter_actor_allocation_changed, self, 0);
	g_object_notify ((GObject *) self, "view");
}


guint game_get_score (Game* self) {
	guint result;
	guint _tmp0_ = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_score;
	result = _tmp0_;
	return result;
}


void game_set_score (Game* self, guint value) {
	guint _tmp0_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_score = _tmp0_;
	g_object_notify ((GObject *) self, "score");
}


static void game_class_init (GameClass * klass) {
	game_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GamePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_game_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_game_set_property;
	G_OBJECT_CLASS (klass)->finalize = game_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_VIEW, g_param_spec_object ("view", "view", "view", clutter_actor_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_SCORE, g_param_spec_uint ("score", "score", "score", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_signal_new ("finished", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void game_instance_init (Game * self) {
	self->priv = GAME_GET_PRIVATE (self);
	self->priv->BLANK_ROW_HEIGHT = 10;
	self->priv->BLANK_COL_WIDTH = 10;
}


static void game_finalize (GObject* obj) {
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
	_g_object_unref0 (self->priv->_grid);
	_g_object_unref0 (self->priv->_view);
	self->priv->_background = (_vala_array_free (self->priv->_background, self->priv->_background_length1 * self->priv->_background_length2, (GDestroyNotify) g_object_unref), NULL);
	self->priv->_foreground_cur = (_vala_array_free (self->priv->_foreground_cur, self->priv->_foreground_cur_length1 * self->priv->_foreground_cur_length2, (GDestroyNotify) g_object_unref), NULL);
	self->priv->_foreground_nxt = (_vala_array_free (self->priv->_foreground_nxt, self->priv->_foreground_nxt_length1 * self->priv->_foreground_nxt_length2, (GDestroyNotify) g_object_unref), NULL);
	_g_object_unref0 (self->priv->_to_move);
	_g_object_unref0 (self->priv->_to_hide);
	_g_object_unref0 (self->priv->_to_show);
	_g_object_unref0 (self->priv->_show_hide_trans);
	_g_object_unref0 (self->priv->_move_trans);
	_g_object_unref0 (self->priv->_settings);
	_g_free0 (self->priv->_saved_path);
	G_OBJECT_CLASS (game_parent_class)->finalize (obj);
}


GType game_get_type (void) {
	static volatile gsize game_type_id__volatile = 0;
	if (g_once_init_enter (&game_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Game), 0, (GInstanceInitFunc) game_instance_init, NULL };
		GType game_type_id;
		game_type_id = g_type_register_static (G_TYPE_OBJECT, "Game", &g_define_type_info, 0);
		g_once_init_leave (&game_type_id__volatile, game_type_id);
	}
	return game_type_id__volatile;
}


static void _vala_game_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
	switch (property_id) {
		case GAME_VIEW:
		g_value_set_object (value, game_get_view (self));
		break;
		case GAME_SCORE:
		g_value_set_uint (value, game_get_score (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_game_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
	switch (property_id) {
		case GAME_VIEW:
		game_set_view (self, g_value_get_object (value));
		break;
		case GAME_SCORE:
		game_set_score (self, g_value_get_uint (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



